//==============================================================
// PSP   (STPP.05)
//     for PSP CFW5.00 M33-6
// STEAR 2009
//--------------------------------------------------------------
// Simple IMEɂ{eLXgGfB^B
// iĂ^GfB^{ɂĂ݂܂B
// ΉĂsR[hCRLFLFłBCRP̂ɂ͑ΉĂ܂B
//--------------------------------------------------------------

#include <pspuser.h>
#include <pspctrl.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <malloc.h>

#include "graphics.h"
#include "zenkaku.h"
#include "draw.h"
#include "sime.h"
#include "osk.h"

//----- }N -----


//----- 萔ݒ -----

#define	VERSION		"PSP Ver0.98"							// Av
#define	INITFILE	"SMEMO.INI"									// ݒt@C
#define	TBY			(24)										// eLXg̈̊JnYW
#define	LWIDTH		(475)										// ʏsɕ\łhbg
#define	WWIDTH		(900)										// zʏsɕ\łhbg
#define	PAGEMOVE	(12)										// y[W̍s
#define	TEXTBLSIZE	(30)										// sR[h擾̏{̈TCY
#define	UNDOSIZE	(500)										// u蒼vL^

//----- vg^Cv錾 -----


//- VXe֘A -

int		SetupCallbacks(void);
int		callbackThread(SceSize args, void *argp);
int		exitCallback(int arg1, int arg2, void *common);

//- ̑ -

int		MenuDLGyn(char *msg,long corFrm,long corIn);

//------ O[oϐ -----

static unsigned int __attribute__((aligned(16))) gList[1000];
volatile int	gExitRequest = 0;

static char	gFolder[1024],										// ƂĂtH_
			gPFolder[1024],										// t@C\t̑ΏۃtH_
			gMonaFile[4][1024];									// monafontt@CǗ
static long gSCor[] = {											// VXe֘A̔zF
				0xFFFFFF,										// F
				0x80FF80,										// ʒm_CAOigj
				0x206020,										// ʒm_CAOij
				0x8080A0,										// x_CAOigj
				0x404090,										// x_CAOij
				0x103010,										// ʒm_CAOiwij
				0x40A040,										// XN[o[igj
				0x306030,										// XN[o[ij
				0xB0FFB0,										// NX[o[io[j
				0x40FFFF,										// fBNg̕F
				0xC04020,										// J[\igj
				0x602010,										// J[\ij
				0x809080,										// j[̑Is
				0xFFC0C0,										// _CAÕL[KC_X
				0x40A040,										// vOXo[̐F
			};
static long	gCor[] = {
				0x804040,										// ^Cg
				0xFFFFFF,										// ^CgF
				0x000000,										// wiF
				0xFFFFFF,										// F
				0x40A040,										// XN[o[igj
				0x306030,										// XN[o[ij
				0xB0FFB0,										// NX[o[io[j
				0x707070,										// ^u
				0x80FF80,										// s
				0x80FF80,										// [EOF]
				0x80FFFF,										// ̑̃Rg[R[h
				0x707070										// Sp󔒕
			};

static char	*gTextClip;											// eLXg̃Rsyp

static int	gSave,												// t@CύXĂ邩i0:Noj
			gCRLF,												// sR[hi0:LF 1:CRLFj
			gTab = 0,											// ^ui0:4 ȊO:8j
			gPSpc = 0,											// Sp󔒂L\邩i0:No ȊO:Yesj
			gPTab = 0,											// ^uL\邩i0:No ȊO:Yesj
			gFont = 0,											// \ɎgtHgi0:_tHg 1:monafont 2:intraFont 3:intraFontPj
			gIME = 0,											// IME̎ށi0:Simple IME ȊO:OSKj
			gRoll = 0,											// g\邩i0:ʌŒ胂[h 1:zʃ[hj
			gLineLen,											// sR[h̖{̃TCY
			gFHeight,											// tHg̍
			gFWidth,											// tHg̍ő啝
			gSLine,												// ʏɕ\os
			gReDraw,											// ŉs͂ݏoi0:oȂ ȊO:oj
			gUndoSize,											// u蒼vf[^
			gUndoPos;											// u蒼vf[^擪ʒu
static long	gLineMax,											// Ŝ̍si=gpĂsR[h̑j
			gLineListMax;										// sR[hXǧ

static float	gXDraw,											// s̃TCY
				gXOffset,										// \JnʒuiEXN[pj
				gXShift;										// ʓ̍悵Ȃ̃TCY

static struct strText{
	long			chainBack;									// Xg`FCiÕR[hj
																//     0xFFFFFFFFȂ疢gpR[hA0xFFFFFFFEȂ擪s
	long			chainNext;									// Xg`FCĩR[hj
																//     0xFFFFFFFFȂŏIs
	unsigned int	back : 1;									// 1 ÕR[h瑱Ă
	unsigned int	next : 1;									// 1 ̃R[hɑĂ
	unsigned int	enter : 1;									// 1 sR[h
	int				textsize;									// {pɊmۂĂ̈̃TCY
	int				len;										// {̒
	char			*text;										// {ւ̃|C^î͎gƂɕʂɊmۂj
} **gText;														// sǗiʏ̈s̃R[hɑΉj

struct strDList{												// fBNgꗗp\
	int		flag;												// 0:fBNg 1:t@C
	char	name[256];											// O
};

static struct {													// eLXg͈͎wʒuǗp
	int		cxr;
	long	rno;
	long	line;
} gTSel[3];

struct strCsrSts{												// J[\ʒuwp
	int		cx;													// ʏł̕J[\XʒuiPʁj
	float	sx;													// ʏł̕J[\XʒuihbgPʁj
	int		cxr;												// _J[\Xʒu
	float	cxb;												// J[\Xʒuw莞̓BڕW|CgihbgPʁj
	int		cy;													// ʏł̕J[\Yʒu
	long	pline;												// ʏ̕\Jns
	long	rno;												// J[\ʒũR[h
	long	rline;												// J[\ʒu̘_s
	int		adjust;												// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
};

static struct {													// u蒼vǗp
	long	pline;												// 삪sꂽsR[h
	int		cxr;												// 삪sꂽsR[h_ʒu
	char	str[3];												// str[0]`[1] /폜
																// str[2]1Ȃ當́A0Ȃ當폜
} gUndo[UNDOSIZE];


//------ s[hw -----

#ifndef	PSP_MODULE_KERNEL
#define	PSP_MODULE_KERNEL	0x1000
#endif
#ifndef	PSP_MODULE_USER
#define	PSP_MODULE_USER		0
#endif

PSP_MODULE_INFO( "PSP", PSP_MODULE_USER, 1, 1 );
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);
PSP_HEAP_SIZE_KB(-800);


//==============================================================
// ʕ\̍XV
//--------------------------------------------------------------
// VRAMʂ̃C[W\ʂ֓]邱Ƃŉʕ\XVB
// _uobt@gpKvŒ̉ʏŕ\s߂̋̍B
// VRAMy[W0y[WAy[W1\y[WŌߑłĂ܂B
//--------------------------------------------------------------

void ScreenView(void)
{
	sceGuStart( GU_DIRECT, gList );
	sceGuCopyImage( GU_PSM_8888, 0, 0, 480, 272, 512, VRAM, 0, 272, 512, VRAM);
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// {^܂őҋ@
//--------------------------------------------------------------

void WaitBtn(void)
{
	SceCtrlData		pad;

	ScreenView();												// ʍXV
	while (!gExitRequest){										// ܂őҋ@
		sceCtrlReadBufferPositive( &pad, 1 );
		if (SIMEgetchar(pad)!=0) break;
		sceDisplayWaitVblankStart();
	}
}

//==============================================================
// {^܂őҋ@
//--------------------------------------------------------------

void Unpush(void)
{
	SceCtrlData		pad;

	ScreenView();												// ʍXV
	while (1){
		sceCtrlReadBufferPositive(&pad, 1);
		if (!(pad.Buttons & 0x00F3F9)) break;					// n{^Sėꂽ
		sceDisplayWaitVblankStart();
	}
}

//==============================================================
// ^Cg
//--------------------------------------------------------------

void DrawTitle(char *path)
{
	char	str[65];
	int		pos,len;

	pos = 0;
	len = strlen(path);
	if (len>62) pos = len - 62;
	strcpy( str, &path[pos] );									// ʂ͂ݏoȂ悤ɕ
	if (gSave)
		strcat( str, " (XV)" );
	CurveBox( 0, 0, 480, 21, 3, gCor[0], gCor[0] );
	mh_print( 6, 1, str, gCor[1] );
	Fill( LWIDTH, 14, 5, 8, gCor[0] );
	HLine( 0, 22, LWIDTH, gCor[3] );
}

//==============================================================
// Xe[^X\
//--------------------------------------------------------------
// flag 1:J[\ʒuƃ[[̋
//      2:[[̋
//--------------------------------------------------------------

void DrawSts(struct strCsrSts *cs,int flag)
{
	static int	bx,lineBak = 0,lxBak = 0;
	int			i,wy,lx,len;
	float		cw,cx;
	long		rno,pos;

	if (flag==1 || lineBak!=cs->rline){							// ωĂȂ͍悵Ȃ
		Fill( 420, 1, 30, 12, gCor[0] );
		DrawVal( 420, 1, (cs->rline)+1, 0, 1, gCor[1] );		// _sʒu
		lineBak = cs->rline;
	}
	mh_print( 450, 1, ":", gCor[1] );
	lx = cs->cx;
	rno = cs->rno;
	while (gText[rno]->back){									// sɐ܂ԂĂꍇ
		rno = gText[rno]->chainBack;
		pos = 0;
		len = 0;
		while (pos<gText[rno]->len){							// s̕𒲂ׂ
			if (gText[rno]->text[pos++]=='\t'){
				if (gTab){
					len = (len + 8) & 0xFF8;					// TAB=8
				} else {
					len = (len + 4) & 0xFFC;					// TAB=4
				}
			} else {
				len++;
			}
		}
		lx += len;
		if (lx>998){
			lx = 998;
			break;
		}
	}
	if (flag==1 || lxBak!=lx){
		Fill( 456, 1, 18, 12, gCor[0] );
		DrawVal( 456, 1, lx+1, -1, 1, gCor[1] );				// ʒu
		lxBak = lx;
	}

	cw = GetStrWidth( gFont,"" )/2;
	if (flag){													// [[
		Fill( 0, 14, LWIDTH, 9, gCor[2] );
		HLine( 0, 22, LWIDTH, gCor[3] );
		i = 0;
		while (i*cw<LWIDTH-1+gXOffset){
			wy = 2;
			if (i%8==1) wy = 1;
			if (i%4==0) wy += 2;
			if (i%8==0){
				wy += 3;
				cx = i*cw - gXOffset;
				if (cx>=0 && cx<LWIDTH-20){
					DrawVal( cx+2, 15, i, -1, 0, gCor[3] );
				}
			}
			cx = i*cw - gXOffset;
			if (cx>=0){
				VLine( cx, 22-wy, wy, gCor[3] );
			}
			i++;
		}
	} else {
		cx = 1 + bx*cw - gXOffset;
		if (cx>=0 && cx<LWIDTH-cw-1)
			XFill( cx, 14, cw-1, 8, gCor[1] );					// J[\ʒuij
	}
	cx = 1 + (cs->cx)*cw - gXOffset;
	if (cx>=0 && cx<LWIDTH-cw-1)
		XFill( cx, 14, cw-1, 8, gCor[1] );						// J[\ʒui\j
	bx = cs->cx;
	VRollBar( LWIDTH, 22, 272-22, cs->pline, gSLine, gLineMax, flag, gCor[4], gCor[5], gCor[6] );
}

//==============================================================
// wsR[h폜
//--------------------------------------------------------------

void DelRec(long rno)
{
	if (gText[rno]){
		free(gText[rno]->text);									// {p̈
		free(gText[rno]);										// sR[h
		gText[rno] = NULL;										// Ή郌R[hXg𖢎gp
		gLineMax--;
	}
}

//==============================================================
// VsR[h擾
//--------------------------------------------------------------
// size   {̈TCYi0:̈͊mۂȂj
// ߂l  -1:Ȃ
//        0`:擾sR[hio[
//--------------------------------------------------------------
// {p̗͍̈ŏŒmۂAőȂȂ炻̓sx萔
// g܂B
//--------------------------------------------------------------

long GetNewRec(int size)
{
	struct strText	*tmp,**text;
	char	*tmpc;
	long	i,rno;

	if (gLineMax+1>=gLineListMax){								// R[hXgȂȂǉ
		text = (struct strText**) realloc( gText,sizeof(struct strText**)*(gLineListMax+1000) );
		if (text==NULL) return (-1);
		gText = text;
		for (i=gLineListMax; i<gLineListMax+1000 ;i++){
			gText[i] = NULL;
		}
		gLineListMax += 1000;
	}
	rno = -1;
	if (gText[gLineMax+1]==NULL){
		rno = gLineMax +1;
	} else {
		for (i=gLineMax; i<gLineListMax ;i++){					// gp̈̍Ō̕疢gp̈TĂ݂
			if (gText[i]==NULL){
				rno = i;
				break;
			}
		}
		if (rno==-1){
			for (i=0; i<gLineListMax ;i++){						// gp̈T
				if (gText[i]==NULL){
					rno = i;
					break;
				}
			}
		}
	}
	if (rno==-1) return (-1);

	tmp = (struct strText*) malloc(sizeof(struct strText));
	if (tmp==NULL) return (-1);
	gText[rno] = tmp;
	gText[rno]->chainBack = 0xFFFFFFFF;
	gText[rno]->chainNext = 0xFFFFFFFF;
	gText[rno]->back = 0;
	gText[rno]->next = 0;
	gText[rno]->enter = 0;
	if (size>gLineLen) size = gLineLen;
	gText[rno]->textsize = size;
	if (size){
		tmpc = (char*) malloc(gText[rno]->textsize);
		if (tmpc==NULL){										// {p̈mۏoȂ
			free(gText[rno]);
			gText[rno] = NULL;
			return (-1);
		}
		gText[rno]->text = tmpc;
	} else {
		gText[rno]->text = NULL;
	}
	gText[rno]->len = 0;
	gLineMax++;
	return (rno);
}

//==============================================================
// sR[h̖{p̈̊g
//--------------------------------------------------------------
// rno sR[hi0xFFFFFFFFƉȂj
// len {̈悪菬ꍇAg
// ߂l  0:I
//        -1:Ȃ
//--------------------------------------------------------------
// w肳ꂽsR[h̖{̈悪w蕶菬ꍇA{̈g
// B
// gꍇ͎wl+50oCg߁igLineLen͒ȂjɊg܂B
// Ȃ݂Ɉxgꂽ{͍̈sR[h폜Ȃk邱Ƃ
// ܂B
//--------------------------------------------------------------

int AddRecText(long rno,int len)
{
	char	*buf;

	if (rno!=0xFFFFFFFF){
		if (gText[rno]->textsize<=len){
			len += 50;
			if (len>gLineLen) len = gLineLen;
			buf = (char*) realloc( gText[rno]->text,len );
			if (buf==NULL) return (-1);							// mۂłȂ
			gText[rno]->textsize = len;
			gText[rno]->text = buf;
		}
	}
	return (0);
}

//==============================================================
// sR[h̑S
//--------------------------------------------------------------
// ɊmۂĂsR[h֘ÃSĉAs̍sR[h
// mۂ܂B
//--------------------------------------------------------------

void InitRec(void)
{
	long	i;

	for (i=0; i<gLineListMax ;i++){								// sR[hSĉ
		DelRec(i);
	}
	free(gText);												// sR[hXg
	gLineListMax = 1000;
	gText = (struct strText**) malloc( sizeof(struct strText*) * gLineListMax );
	for (i=0; i<gLineListMax ;i++){
		gText[i] = NULL;
	}

	gLineMax = -1;
	GetNewRec(TEXTBLSIZE);
	gText[0]->chainBack = 0xFFFFFFFE;
	gLineMax = 0;

	gUndoSize = 0;												// u蒼v
	gUndoPos = 0;
	gSave = 0;
	gCRLF = 1;													// ftHg̉sR[hCR,LF
	gTSel[0].rno = -1;											// ͈͑I
	gXOffset = 0;												// EXN[p
	gXShift = 0;
	gXDraw = LWIDTH;
}

//==============================================================
// hbgPʂŎ̃^uʒu߂
//--------------------------------------------------------------
// Sp̔̕ɂĂ܂B
//--------------------------------------------------------------

float GetTabPos(float x)
{
	float	px,wx;

	wx = GetStrWidth(gFont,"") * (gTab ? 8 : 4) /2;			// ''ɓʂȈӖ͂ȂASpm肽
	px = 0;
	while (px<=x){
		px += wx;
	}
	return (px);
}

//==============================================================
// t@Cǂݍ
//--------------------------------------------------------------
// ߂l  2:[U[ɂ蒆fꂽ
//         1:sR[h擾oȂiȂj
//         0:
//        -1:si[NȂj
//        -2:sit@CJȂj
//--------------------------------------------------------------
// sR[h̎擾ɎsꍇA̎_œǂݍ݂I܂B
// eLXg4096oCgǂݍ݂Ȃ烌R[hPʂɕĂ܂B
// sR[h̖{͍̈ŏőlŊmۂAem肵_ŃTCY
// œK]vȃgȂ悤ɂc悤ƂAʂȂB
// reallocŏkĂ͉Ȃ炵B
// dȂ̂Ŗ{m肵_Ŗ{̈mۂ悤ɂĂ܂B
//--------------------------------------------------------------

//----- sR[h̖{Zbg -----

int fileloadText(long rno,char *text,int cnt)
{
	char	*buf;
	long	rno2;

	buf = (char*) malloc(cnt+1);								// {̈̊m
	if (buf){													// mۂł
		gText[rno]->text = buf;
		gText[rno]->textsize = cnt +1;
		memcpy( gText[rno]->text,text,cnt );
		gText[rno]->len = cnt;
		return (0);
	} else {													// Ȃ
		rno2 = gText[rno]->chainBack;
		DelRec(rno);
		gText[rno2]->chainNext = 0xFFFFFFFF;
		gText[rno2]->next = 0;
		return (-1);
	}
}

//----- ̍sR[h쐬 -----

int fileloadNextLine(long *rno,char *text,int *cnt,int *len,float *wx)
{
	long	rno2;

	if (fileloadText( *rno,text,*cnt )) return (-1);			// {Zbg
	*cnt = 0;
	*len = 0;
	*wx = 0;
	rno2 = GetNewRec(0);
	if (rno2==-1) return (-1);									// sR[h擾oȂ
	gText[*rno]->chainNext = rno2;
	gText[*rno]->next = 1;										// ̍sɑĂ
	gText[rno2]->chainBack = (*rno);
	gText[rno2]->back = 1;										// O̍s瑱Ă
	*rno = rno2;
	return (0);
}

//----- C -----

int fileload(char *fname)
{
	SceCtrlData		pad;
	char	*data,text[WWIDTH/2+2],msg[128],c[3] = {0,0,0};
	int		fd,cnt,len,ret;
	long	filesize,pos,poscnt,rno,rno2;
	float	wc,wx;

	//----- vOXo[ -----

	Progressbar1( -1, 135, 0, "~:LZ", gSCor[7], gSCor[13], gSCor[1], gSCor[2] );
	ScreenView();												// ʍXV

	//----- f[^R[h -----

	InitRec();

	//----- t@Cǂݍ -----

	msg[0] = '\0';
	filesize = 0;
	fd = sceIoOpen( fname, PSP_O_RDONLY, 0777 );
	data = NULL;
	if (fd>=0){
		filesize = sceIoLseek( fd, 0, SEEK_END );
		sceIoLseek( fd, 0, SEEK_SET );
		data = (char*) malloc(4096);
		if (data==NULL){										// mۂłȂ
			sceIoClose(fd);
			strcpy( msg, "[Nmۂł܂ł" );
			DiaBox1( -1, 120, 0, msg, gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
		} else {
			sceIoRead( fd, data, 4096 );
		}
	} else {
		return (-2);											// t@CJȂ
	}

	if (msg[0]){												// G[
		WaitBtn();												// ܂őҋ@
		return (-1);
	}

	//----- R[hPʂɕ -----

	pos = 0;
	poscnt = 0;
	cnt = 0;
	len = 0;
	wx = 0;
	gCRLF = 0;
	ret = 0;
	rno = 0;
	while (filesize>poscnt+pos && !gExitRequest){
		c[0] = data[pos++];
		if (pos>=4096){													// eLXg[h
			poscnt += pos;
			pos = 0;
			sceIoRead( fd, data, 4096 );
			Progressbar2( poscnt, filesize, gSCor[14] );				// vOXo[̍XV
			ScreenView();												// ʍXV
			sceCtrlReadBufferPositive( &pad, 1 );
			if (SIMEgetchar(pad)==SIME_KEY_CROSS){
				ret = 2;
				break;
			}
		}
		if (c[0]==0) c[0] = 1;											// oCif[^'\0'܂܂ƕsŝ
		if (c[0]=='\r'){												// CR͎̂Ă
			gCRLF = 1;
		} else if (c[0]=='\n'){											// LF
			text[cnt++] = '\n';
			gText[rno]->len = cnt;
			if (fileloadText( rno,text,cnt )){							// {Zbg
				ret = 1;
				break;
			}
			cnt = 0;
			len = 0;
			wx = 0;
			rno2 = GetNewRec(0);
			if (rno2==-1){												// sR[h擾łȂ
				ret = 1;
				break;
			}
			gText[rno]->chainNext = rno2;
			gText[rno]->enter = 1;										// s
			gText[rno2]->chainBack = rno;
			rno = rno2;
		} else {
			if (chkSJIS(c[0])){											// Spꍇ
				c[1] = data[pos++];
				if (pos>=4096){											// eLXg[h
					poscnt += pos;
					pos = 0;
					sceIoRead( fd, data, 4096 );
					Progressbar2( poscnt, filesize, gSCor[14] );		// vOXo[̍XV
					ScreenView();										// ʍXV
					sceCtrlReadBufferPositive( &pad, 1 );
					if (SIMEgetchar(pad)==SIME_KEY_CROSS){
						ret = 2;
						break;
					}
				}
				wc = GetStrWidth( gFont,c );
				if (len>=gLineLen-1 || (wx+wc>=(gRoll ? WWIDTH : LWIDTH))){	// sɎ܂Ȃ
					if (fileloadNextLine( &rno, text, &cnt, &len, &wx )){	// ̍s쐬
						ret = 1;
						break;
					}
				}
				text[cnt++] = c[0];
				text[cnt++] = c[1];
				len += 2;
				wx += wc;
			} else {													// pꍇ
				c[1] = '\0';
				wc = GetStrWidth( gFont,c );
				if (wx+wc>=(gRoll ? WWIDTH : LWIDTH) && c[0]!='\t'){	// sɎ܂Ȃ
					if (fileloadNextLine( &rno, text, &cnt, &len, &wx )){	// ̍s쐬
						ret = 1;
						break;
					}
				}
				text[cnt++] = c[0];
				if (c[0]=='\t'){										// ^u
					if (gTab){
						len = (len + 8) & 0xFF8;						// TAB=8
					} else {
						len = (len + 4) & 0xFFC;						// TAB=4
					}
					wx = GetTabPos(wx);
					wc = 0;
				} else {
					len++;
					wx += wc;
				}
				if (len>=gLineLen || wx+wc>=(gRoll ? WWIDTH : LWIDTH)){
					if (fileloadNextLine( &rno, text,&cnt, &len, &wx )){	// ̍s쐬
						ret = 1;
						break;
					}
				}
			}
		}
	}
	fileloadText( rno,text,cnt+1 );										// ŏIssꍇ̑΍
	gText[rno]->len = cnt;
	gText[rno]->chainNext = 0xFFFFFFFF;

	//----- n -----

	if (gExitRequest) ret = 2;
	sceIoClose(fd);
	free(data);
	return (ret);
}

//==============================================================
// t@C
//--------------------------------------------------------------
// ߂l  0:
//        -1:[N̎擾Ɏs
//        -2:ۑt@C̃I[vɎs
//--------------------------------------------------------------
// [N̈Ƀv[eLXgȂt@CɏoĂ܂B
// [N̈̓TCYƂɉp^[mۂɃgCA\Ȍ傫̈
// 擾悤ɂĂ܂B
// cʂȂꍇAɒԂ鎖ł傤B
// sR[h͓ǂݍ݌ƓɂȂ悤ɕ␳܂B
//--------------------------------------------------------------

int filesave(char *fname)
{
	char	*data;
	int		i,fd;
	long	ws[5] = {65536,16384,4096,1024,WWIDTH/2};
	long	rno,pos,line,worksize;

	//----- [N̈̊m -----

	for (i=0; i<5 ;i++){										// [N̈̑傫
		worksize = ws[i];
		data = (char*) malloc(worksize);
		if (data) break;
	}
	if (data==NULL) return (-1);								// [N̈悪mۂłȂ

	//----- vOXo[ -----

	Progressbar1( -1, 135, 0, "LZo܂", gSCor[7], gSCor[13], gSCor[1], gSCor[2] );
	ScreenView();												// ʍXV

	//----- {t@C֏o -----

	fd = sceIoOpen( fname, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
	if (fd<0){
		free(data);
		return (-2);											// t@CJȂ
	}
	rno = 0;
	pos = 0;
	line = 0;
	do{
		if (pos+gText[rno]->len > worksize){					// [NɎ܂ȂȂt@Cɏo
			Progressbar2( line, gLineMax, gSCor[14] );			// vOXo[̍XV
			ScreenView();										// ʍXV
			sceIoWrite( fd, data, pos );
			pos = 0;
		}
		memcpy( &data[pos], gText[rno]->text, gText[rno]->len );
		if (gText[rno]->enter && gCRLF){						// sR[hC
			data[pos+gText[rno]->len-1] = '\r';
			data[pos+gText[rno]->len] = '\n';
			pos++;
		}
		pos += gText[rno]->len;
		line++;
		rno = gText[rno]->chainNext;
	}while (rno!=0xFFFFFFFF && !gExitRequest);
	if (pos){													// [NɎcĂeLXgt@C
		sceIoWrite( fd, data, pos );
	}
	sceIoClose(fd);

	//----- I -----

	gSave = 0;
	free(data);
	return (0);
}

//==============================================================
// f[^̓ǂݍ
//--------------------------------------------------------------

void LoadEnv(void)
{
	const char		it[12][11] = {"FONT","ROLL","IME","TABW","SPCP","TABP","FOLDER1","FOLDER2","FONT12A","FONT12W","FONT16A","FONT16W"};
	char	c,path[1024],buf[1030],*p;
	int		i,fd,no;
	FILE*	fp1;

	if (getcwd( path,1024 )==NULL){								// JgfBNg̎擾
		strcpy( path,"ms0:");
	}
	strcat( path,"/" );
	strcat( path,INITFILE );
	fp1 = fopen( path,"r" );
	if (fp1!=NULL){
		while (1){												// g[N؂oAeϐɒlݒ肷
			if (fgets( buf,1030,fp1 )==NULL) break;
			for (i=0; i<strlen(buf) ;i++){						// sR[h폜
				if (buf[i]<32 && buf[i]!='\t') buf[i] = '\0';
			}
			p = strtok( buf," =\t" );
			no = -1;
			for (i=0; i<12 ;i++){
				if (strcmp(p,it[i])==0) no = i;
			}
			p = strtok( NULL," =\t" );
			c = (unsigned char) p[0] - '0';
			switch (no){
			case 0:
				if (c>4) c = 0;
				gFont = c;
				break;
			case 1:
				if (c>1) c = 0;
				gRoll = c;
				break;
			case 2:
				if (c>1) c = 0;
				gIME = c;
				break;
			case 3:
				if (c>1) c = 0;
				gTab = c;
				break;
			case 4:
				if (c>1) c = 0;
				gPSpc = c;
				break;
			case 5:
				if (c>1) c = 0;
				gPTab = c;
				break;
			case 6:
				fd = sceIoDopen(p);
				sceIoDclose(fd);
				if (fd>=0){											// tH_݂Ȃ
					strncpy( gFolder,p,1023 );
					gFolder[1023] = '\0';
				}
				break;
			case 7:
				fd = sceIoDopen(p);
				sceIoDclose(fd);
				if (fd>=0){											// tH_݂Ȃ
					strncpy( gPFolder,p,1023 );
					gPFolder[1023] = '\0';
				}
				break;
			case 8:
				fd = sceIoOpen( p, PSP_O_RDONLY, 0777 );
				sceIoDclose(fd);
				if (fd>=0){											// t@C݂Ȃ
					strncpy( gMonaFile[0],p,1023 );
					gMonaFile[0][1023] = '\0';
				}
				break;
			case 9:
				fd = sceIoOpen( p, PSP_O_RDONLY, 0777 );
				sceIoDclose(fd);
				if (fd>=0){											// t@C݂Ȃ
					strncpy( gMonaFile[1],p,1023 );
					gMonaFile[1][1023] = '\0';
				}
				break;
			case 10:
				fd = sceIoOpen( p, PSP_O_RDONLY, 0777 );
				sceIoDclose(fd);
				if (fd>=0){											// t@C݂Ȃ
					strncpy( gMonaFile[2],p,1023 );
					gMonaFile[2][1023] = '\0';
				}
				break;
			case 11:
				fd = sceIoOpen( p, PSP_O_RDONLY, 0777 );
				sceIoDclose(fd);
				if (fd>=0){											// t@C݂Ȃ
					strncpy( gMonaFile[3],p,1023 );
					gMonaFile[3][1023] = '\0';
				}
				break;
			}
		}
		fclose (fp1);
	}
}

//==============================================================
// f[^̕ۑ
//--------------------------------------------------------------

//----- ln -----

int SaveEnvSub1(char *buf,int pos,int item,int data)
{
	const char	it[6][5] = {"FONT","ROLL","IME","TABW","SPCP","TABP"};
	int	i;

	for (i=0; i<strlen(it[item]) ;i++){
		buf[pos++] = it[item][i];
	}
	buf[pos++] = ' ';
	buf[pos++] = '=';
	buf[pos++] = ' ';
	buf[pos++] = '0' + data;
	buf[pos++] = '\r';
	buf[pos++] = '\n';
	return (pos);
}

//----- n -----

int SaveEnvSub2(char *buf,int pos,int item,char *data)
{
	const char	it[6][11] = {"FOLDER1 = ","FOLDER2 = ","FONT12A = ","FONT12W = ","FONT16A = ","FONT16W = "};
	int	i;

	for (i=0; i<strlen(it[item]) ;i++){
		buf[pos++] = it[item][i];
	}
	for (i=0; i<strlen(data) ;i++){
		buf[pos++] = data[i];
	}
	buf[pos++] = '\r';
	buf[pos++] = '\n';
	return (pos);
}

//----- C -----

void SaveEnv(void)
{
	char	path[1024],buf[3100];
	int		fd,pos;

	pos = 0;
	pos = SaveEnvSub1( buf, pos, 0, gFont );
	pos = SaveEnvSub1( buf, pos, 1, gRoll );
	pos = SaveEnvSub1( buf, pos, 2, gIME );
	pos = SaveEnvSub1( buf, pos, 3, gTab );
	pos = SaveEnvSub1( buf, pos, 4, gPSpc );
	pos = SaveEnvSub1( buf, pos, 5, gPTab );
	pos = SaveEnvSub2( buf, pos, 0, gFolder );
	pos = SaveEnvSub2( buf, pos, 1, gPFolder );
	pos = SaveEnvSub2( buf, pos, 2, gMonaFile[0] );
	pos = SaveEnvSub2( buf, pos, 3, gMonaFile[1] );
	pos = SaveEnvSub2( buf, pos, 4, gMonaFile[2] );
	pos = SaveEnvSub2( buf, pos, 5, gMonaFile[3] );

	if (getcwd( path,1024 )==NULL){								// JgfBNg̎擾
		strcpy( path,"ms0:");
	}
	strcat( path,"/" );
	strcat( path,INITFILE );
	fd = sceIoOpen( path, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
	if (fd>=0){
		sceIoWrite( fd, buf, pos );
		sceIoClose(fd);
	}
}

//==============================================================
// ύX̊eʊ֌W̃p[^ݒ
//--------------------------------------------------------------

void setScreen(void)
{
	if (gFont==2){												// 16hbgmonafont
		gSLine = 14;											// ʍs
		gFHeight = 18;											// s
		gFWidth = 16;											// őtHg
		gReDraw = 1;											// ŉs͂ݏo
	} else {													// ̑̃tHg
		gSLine = 19;											// ʍs
		gFHeight = 13;											// s
		gFWidth = 12;											// őtHg
		gReDraw = 0;											// ŉs͂ݏoȂ
	}

	if (gRoll){													// ̃TCYɍ킹čsR[h̖{̃TCYύX
		gLineLen = WWIDTH / 2 +2;
	} else {
		gLineLen = LWIDTH / 2 +2;
	}
}

//==============================================================
// 
//--------------------------------------------------------------
// ̓\[XgIMEɏ]Simple IMEOSKŐ؂ւ܂B
// OSKgpɉʃC[WҔobt@mۂłȂꍇ
// Simple IMEgp܂B
//--------------------------------------------------------------

void StrInput(char *str,SceCtrlData pad)
{
	DrawImg	*image;

	if (gIME){													// OSKI
		image = DrawImgCreate(480,272);
		if (image){
			str[0] = SIMEgetchar(pad);
			DrawCursor(str[0]);									// SIMEJ[\̍
			if (str[0]==0x02){									// Ă
				BoxCopy( image, 0, 0 );
				oskSetupGu(gList);
				oskInput( "", "", str );
				initGraphics();
				flipScreen();									// ftHgł̓y[Wݒɕsŝ
				BoxPaste( image, 0, 0 );
			}
			if (image){
				DrawImgFree(image);
			}
		} else {												// wȋҔoȂꍇ
			SIMEgets( str, pad );
		}

	} else {													// Simple IMEI
		SIMEgets( str, pad );									// ͕̎擾
	}
}

//==============================================================
// Sp/p肠ňꕶ
//--------------------------------------------------------------

int INBack(char *str,int pos)
{
	int pos2,step;

	if (pos>0){
		pos2 = 0;
		while (1){
			if (chkSJIS(str[pos2])){
				step = 2;
			} else {
				step = 1;
			}
			if (pos2+step>=pos) break;
			pos2 += step;
		}
		pos = pos2;
	}
	return (pos);
}

//==============================================================
// 
//--------------------------------------------------------------
// title  ^Cg
// size   ͗̕iő50܂Łj
// inStr  ͕̏l
// outStr ͌
// ߂l 0   :{^ŏI
//        ȊO:~{^ŃLZꂽ
//--------------------------------------------------------------
// Simple IME𗘗pėpPC͂łB
// {^ŏIꍇAoutStrɓ͕񂪕ԂB
// ~{^ŏIꍇAoutStrɂinStrԂB
//--------------------------------------------------------------

int InputName(char *title,int size,char *inStr,char *outStr)
{
	SceCtrlData pad;
	char	str[64],cr[64];
	int		i,cx,cy,x,pos,len,p,dr,end;

	if (size>50) size = 50;

	SIMEfont( 0, 12 );											// SIMẼtHg𓌉_tHg
	SIMEcursor( 2, &cx, &cy );									// J[\̏ݒ

	//----- _CAO\z -----

	CurveBox( 78, 70, 24+300, 41, 4, gSCor[1], gSCor[2] );		// bZ[W_CAO
	x = 78 + 324/2 - strlen(title)*6/2;
	mh_print( x, 75, title, gSCor[1] );
	x = 78 + 324/2 - (size*6+2)/2;								// ͗ʒu
	BoxFill(  x, 91, size*6+2, 14, 0, 0 );
	x += 1;
	cy = 92;
	strcpy( str, inStr );										// ̏l
	len = strlen(str);
	pos = len;
	mh_print( x, cy, str, gSCor[0] );

	//----- ͏ -----

	end = 1;
	while (!gExitRequest && end){
		cx = x + pos * 6;
		sceCtrlReadBufferPositive( &pad,1 );
		StrInput( cr, pad );
		if (cr[0]!=0){											// ͂
			dr = 0;												// 邩i0:Noj
			if (cr[0]<32U || cr[0]==0x7F){						// Rg[R[hꍇ
				switch(cr[0]){
				case SIME_KEY_CIRCLE:							//  [Enter]
					end = 0;
					break;
				case SIME_KEY_CROSS:							// ~ [ESC]
					end = 0;
					break;
				case SIME_KEY_UP:								// igpj
					break;
				case SIME_KEY_DOWN:								// igpj
					break;
				case SIME_KEY_LEFT:								// 
					pos = INBack( str, pos );
					break;
				case 0x08:										// [BS]
				case 0x7F:										// [DEL]
					if (len>0){
						if (cr[0]==0x08){
							pos = INBack( str, pos );
						}
						if (chkSJIS(str[pos])){
							strcpy( &str[pos], &str[pos+2] );
							len -= 2;
						} else {
							strcpy( &str[pos], &str[pos+1] );
							len -= 1;
						}
						dr = 1;
					}
					break;
				case SIME_KEY_RIGHT:							// 
					if (chkSJIS(str[pos])){
						pos += 2;
					} else {
						if (pos<len){
							pos++;
						}
					}
					break;
				}
			} else {											// ꍇ
				p = 0;
				while (cr[p]!='\0'){
					if (chkSJIS(cr[p])){						// Sp
						if (len<=size-2){
							for (i=0; i<len-pos ;i++)
								str[len-1+2-i] = str[len-1-i];
							str[pos++] = cr[p++];
							str[pos++] = cr[p++];
							len += 2;
							dr = 1;
						} else {
							break;
						}
					} else if (cr[p]>=32){						// p
						if (len<=size-1){
							for (i=0; i<len-pos ;i++)
								str[len-1+1-i] = str[len-1-i];
							str[pos++] = cr[p++];
							len += 1;
							dr = 1;
						} else {
							break;
						}
					} else {									// Rg[R[h͖
						p++;
					}
				}
				str[len] = '\0';
			}
			if (dr){											// ̍XV
				BoxClr( x, cy, size*6, 12 );
				mh_print( x, cy, str, gSCor[0] );
			}
		}

		sceDisplayWaitVblankStart();
		ScreenView();
	}

	SIMEfont(gFont,(gFont==2 ? 16 : 12));						// SIMEtHgɖ߂

	//----- ߂l -----

	if (cr[0]==0x0D){											// [Enter]ŏIĂ
		strcpy( outStr, str );
		return (0);
	} else {
		strcpy( outStr, inStr );
		return (-1);
	}
}

//==============================================================
// w肳ꂽfBNg̃Ggꗗ擾
//--------------------------------------------------------------
// ߂lF擾GgiOȂ疳j
//--------------------------------------------------------------

struct strDList* GetDir(char *DirName,int *count,struct strDList *DList)
{
	static SceIoDirent	dir;									// Ȃƃt[Y
	int 	dfd,ret,DListMax;

	free(DList);
	dfd = sceIoDopen(DirName);
	DListMax = 1;
	if (dfd>=0){
		do{														// Gg[JEg
			memset( &dir, 0, sizeof(dir) );						// Ȃƃt[Y
			ret = sceIoDread( dfd, &dir );
			if (strlen(dir.d_name)) DListMax++;
		}while (ret>0);
		sceIoDclose(dfd);
	}
	DList = (struct strDList*) malloc(sizeof(struct strDList) * DListMax);
	DList[DListMax-1].name[0] = '\0';

	(*count) = 0;
	if (DListMax==1) return(0);									// Gg[/fBNg

	dfd = sceIoDopen(DirName);
	do{
		memset( &dir, 0, sizeof(dir) );							// Ȃƃt[Y
		ret = sceIoDread( dfd, &dir );
		if (strlen(dir.d_name)){								// Ô͖
			if (FIO_SO_ISDIR(dir.d_stat.st_attr)){
				if (strcmp(dir.d_name,".")!=0 && strcmp(dir.d_name,"..")!=0 ){
					strcpy( DList[*count].name, dir.d_name );
					DList[(*count)++].flag = 0;					// fBNg
				}
			} else {
				strcpy( DList[*count].name, dir.d_name );
				DList[(*count)++].flag = 1;						// t@C
			}
		}
	}while (*count<DListMax && ret>0);
	sceIoDclose(dfd);
	return (DList);
}

//==============================================================
// t@CỈʍ
//--------------------------------------------------------------
// flagF1 
//--------------------------------------------------------------
// 悷Kv̖ꍇ͍悵ȂB
// Pʂ14s\B
//--------------------------------------------------------------

void DrawSFsub(struct strDList *DList,int y,int pos)
{
	char	str[64];

	memcpy( str, DList[pos+y].name, 62 );
	str[63] = '\0';												// ȈՓIȕ
	if (DList[pos+y].flag){
		mh_print( 40+11, 40+6+12+4+y*12, str, gSCor[0] );
	} else {
		mh_print( 40+11, 40+6+12+4+y*12, str, gSCor[9] );
	}
}

void DrawSF(struct strDList *DList,int y,int pos,int max,int flag)
{
	static int	y2,pos2;
	int			i;

	VRollBar( 40+10+380-6, 40+6+12+4, 168, pos, 14, max, flag, gSCor[6], gSCor[7], gSCor[8] );
	if (flag){
		pos2 = -1;
		y2 = -1;
	}
	if (pos!=pos2){												// /J[\̍폜
		Fill( 40+10, 40+6+12+4, 380-6, 168, gSCor[5] );
	} else if (y!=y2){
		Fill( 40+10, 40+6+12+4+y2*12, 380-6, 12, gSCor[5] );
	}

	if ((max && y!=y2) || pos!=pos2){							// GgȂJ[\\
		CurveBox( 40+10, 40+6+12+4+y*12, 380-6, 12, 0, gSCor[10], gSCor[11] );
	}

	if (pos!=pos2){												// ʑŜĕ`
		pos2 = pos;
		y2 = y;
		for (i=0; i<14 ;i++){
			if (pos+i>=max) break;
			DrawSFsub( DList, i, pos );
		}
	} else if (y!=y2){											// J[\ʒuĕ`
		DrawSFsub( DList, y2, pos2 );							// ÕJ[\ʒu
		DrawSFsub( DList, y, pos );								// ̃J[\ʒu
		y2 = y;
	}
}

//==============================================================
// t@CI
//--------------------------------------------------------------
// InitDir FfBNgʒu
// FileNameFftHgt@Cit@C͎̎̃ftHgj
// dir     FIꂽt@CitpXj
// flag    F 0 t@CIit@Cǂݍݗpj
//         F-1 t@ĆiOtĕۑpj
// ߂l  F 0 Iit@CIꂽj
//           -1 LZꂽ
//--------------------------------------------------------------
// fBNgԂړt@CIB
// Gg̓̋łB
// LZꂽꍇAdir̓e͕ωȂB
//--------------------------------------------------------------

//----- ݂̃pX\ -----

void DrawSFPath(char *path)
{
	char	str[64];
	int		pos,len;

	pos = 0;
	len = strlen(path);
	if (len>61){
		pos = len - 61;
	}
	strcpy( str, &path[pos] );									// pX61o

	Fill( 40+10, 25+6+12+4, 380-6, 12, gSCor[5] );
	mh_print( 40+11, 25+6+12+4, str, gSCor[0] );
}

//----- _CAO̍\z -----

void DrawSFRe(char *title,int y,int pos,int count,struct strDList *DList,char *DirName)
{
	CurveBox( 40, 25, 400, 227, 4, gSCor[1], gSCor[2] );
	mh_print( 40+10, 25+6, title, gSCor[1] );
	mh_print( 40+400-10-54*6, 25+227-6-12, "[START]:ٍ̧폜  :I  ~:ݾ  :t@C", gSCor[1] );
	DrawSFPath( DirName );
	DrawSF( DList, y, pos, count, 1 );
}

//----- ㏑`FbN -----

int DrawSFFile(char *DirName,char *FileName)
{
	char	path[1024];
	int		fd;

	strcpy( path,DirName );
	strcat( path,FileName );
	fd = sceIoOpen( path, PSP_O_RDONLY, 0777 );
	sceIoClose(fd);
	if (fd>=0){
		if (!MenuDLGyn( "w肳ꂽt@C͊ɑ݂Ă܂B\n㏑܂낵łH", gSCor[3], gSCor[4] ))
			return (0);
	}
	return (-1);
}

//----- C -----

int SelectFile(char *title,char *InitDir,char *FileName,char *dir,int flag)
{
	SceCtrlData		pad;
	struct strDList	*DList;
	char			*p1,*p2,DirName[1024],backDir[256],outName[64],str[1024];
	int				i,y,pos,ret,count,len;

	strcpy( DirName, InitDir );
	DList = GetDir( DirName, &count, NULL );

	y = 0;
	pos = 0;
	DrawSFRe( title, y, pos, count, DList, DirName );			// _CAO\z

	if (flag){													// t@C
		if (!InputName( "t@C͂Ă",50,FileName,outName)){
			if (DrawSFFile(DirName,outName)){					// ㏑x
				strcpy( dir, DirName );
				strcat( dir, outName );
				free(DList);									// t@CXgp
				return (0);										// Ō肳ꂽꍇ
			}
		}
		DrawSF( DList, y, pos, count, 1 );						// ʍXV
	}

	while (!gExitRequest){										// L[̓C[v
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
		case SIME_KEY_RIGHT:									// 
			if (strlen(DList[pos+y].name)!=0){
				if (DList[pos+y].flag){							// t@C̏ꍇ
					if (ret==SIME_KEY_CIRCLE){					// t@CI͂܂ŌL[
						if (!flag || DrawSFFile(DirName,DList[pos+y].name)){	// ㏑x
							strcpy( InitDir, DirName );
							strcpy( dir, DirName );
							strcat( dir, DList[pos+y].name );
							free(DList);						// t@CXgp
							return (0);							// t@CI
						} else {
							DrawSF( DList, y, pos, count, 1 );	// ʍXVix_CAȌj
						}
					}
				} else {										// fBNg̏ꍇ
					strcat( DirName, DList[pos+y].name );
					strcat( DirName, "/" );
					DrawSFPath( DirName );
					DList = GetDir( DirName, &count, DList );	// fBNgꗗ̎擾
					pos = 0;
					y = 0;
					DrawSF( DList, y, pos, count, 1 );			// ʍXV
				}
			}
			break;
		case SIME_KEY_CROSS:									// ~
			free(DList);										// t@CXgp
			return (-1);
			break;
		case SIME_KEY_TRIANGLE:									// 
			if (!InputName( "t@C͂Ă",50,FileName,outName)){
				if (!flag || DrawSFFile(DirName,outName)){		// ㏑x
					strcpy( InitDir, DirName );
					strcpy( dir, DirName );
					strcat( dir, outName );
					free(DList);								// t@CXgp
					return (0);									// Ō肳ꂽꍇ
				}
			}
			DrawSF( DList, y, pos, count, 1 );					// ʍXV
			break;
		case 0x08:
		case SIME_KEY_LEFT:										// 
			p1 = strchr( DirName, '/' );
			p2 = strrchr( DirName, '/' );
			if (p1!=p2){										// ݈ʒu[gꍇ͏Ȃ
				len = strlen(DirName);
				DirName[len-1] = '\0';							// Ō'/'폜
				p2 = strrchr( DirName, '/' );					// Ԍɂ'/'̈ʒu
				strcpy( backDir, &p2[1] );						// ܂ŋtH_ۑ
				p2[1] = '\0';									// Ԍɂ'/'̈ʒuȌ폜
				DrawSFPath( DirName );
				DList = GetDir( DirName, &count, DList );		// fBNgꗗ̎擾
				pos = 0;
				y = 0;
				for (i=0; i<count ;i++){						// ܂ŋtH_̏ɃJ[\Zbg
					if (!strcmp( backDir,DList[i].name )){
						if (i<13){
							y = i;
						} else {
							y = 13;
							pos = i - 13;
						}
					}
				}
				DrawSF( DList, y, pos, count, 1 );				// ʍXV
			}
			break;
		case SIME_KEY_UP:										// 
			if (y>0){
				y--;
			} else if (pos>0) pos--;
			DrawSF( DList, y, pos, count, 0 );
			break;
		case SIME_KEY_DOWN:										// 
			if (pos+y<count-1){
				if (y<13){
					y++;
				} else {
					pos++;
				}
			}
			DrawSF( DList, y, pos, count, 0 );
			break;
		case SIME_KEY_LTRIGGER:									// [L]
			pos -= 12;
			if (pos<0) pos = 0;
			DrawSF( DList, y, pos, count, 0 );
			break;
		case SIME_KEY_RTRIGGER:									// [R]
			pos += 12;
			if (pos+13>count-1){
				pos = count-1-13;
				if (pos<0) pos = 0;
			}
			DrawSF( DList, y, pos, count, 0 );
			break;
		case SIME_KEY_START:									// [START]
			if (strlen(DList[pos+y].name)!=0){
				if (DList[pos+y].flag){							// t@C̏ꍇ
					strcpy( str, DList[pos+y].name );
					if (strlen(str)>63) str[64] = '\0';
					strcat( str, " 폜܂B" );
					if (MenuDLGyn( str, gSCor[1], gSCor[2] )){	// YesȂ
						strcpy( str, DirName );
						strcat( str, DList[pos+y].name );
						sceIoRemove( str );						// t@C폜
						DList = GetDir( DirName, &count, DList );	// fBNgꗗ̎擾
					}
					DrawSF( DList, y, pos, count, 1 );			// ʍXV
				}
			}
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}
	free(DList);												// t@CXgp
	return (-1);
}

//==============================================================
// w蕨sɑΉsR[h擾
//--------------------------------------------------------------
// sR[h͒ǉꂽ폜ꂽ肷邽߃R[hƕsԍ͈v
// ܂B
// sԍiʂɕ\ꂽԂł̍sԍjɑΉĂ郌R[h擾
// 邽߂ɐ擪s烊Xg`FCHwsT܂B
//--------------------------------------------------------------

long GetRNo(long line)
{
	long	no,rno;

	no = 0;
	rno = 0;
	while (no!=line){											// Xg`FCHȂsJEg
		if (gText[rno]->chainNext==0xFFFFFFFF) break;
		rno = gText[rno]->chainNext;
		no++;
	}
	return (rno);
}

//==============================================================
// ݂̍sR[h瑊ΓIɈړsR[h擾
//--------------------------------------------------------------
// ݂̍sR[hĂꍇɗLłB
// 擪sOɂ͈ړ܂A擪sŎ~܂܂B
// ŏIs𒴂0xFFFFFFFFԂ܂B
//--------------------------------------------------------------

long ShiftRNo(long rno,int shift)
{
	int		i;

	if (shift<0){
		for (i=0; i<(-shift) ;i++){
			rno = gText[rno]->chainBack;
			if (rno==0xFFFFFFFE) break;
		}
		return (rno);
	} else {
		for (i=0; i<shift ;i++){
			rno = gText[rno]->chainNext;
			if (rno==0xFFFFFFFF) break;
		}
		return (rno);
	}
}

//==============================================================
// wsR[hɑΉ镨s擾
//--------------------------------------------------------------

long GetLine(long rno)
{
	long	line,rnoP;

	line = 0;
	rnoP = 0;
	while (rnoP!=rno){											// Xg`FCHȂsJEg
		if (gText[rnoP]->chainNext==0xFFFFFFFF) break;
		rnoP = gText[rnoP]->chainNext;
		line++;
	}
	return (line);
}

//==============================================================
// R[heʂɕ\
//--------------------------------------------------------------
// y       \sʒu
// rno     \s̃R[h
//--------------------------------------------------------------
// PʂŔwiAĂ܂B
// sȍ~͔wiFŏB
// gXOffset,gXShift,gXDraw̎wɏ]ĕ\s܂B
// gXOffset͉ʊO̕\Ȃ͈́AgXShift͉ʓōsȂ͈́A
// gXDraw͂̈ʒuȍ~͍sȂAƂݒłB
// `ʔ͈͂Oč悳ꂽꍇiXN[o[ɕ㏑jɔA
// `ʔ͈͊OC[W𖢎gpVRAMiy[W3jɑҔĂ܂B
//--------------------------------------------------------------

void DrawRecLine2(int y,long rno,long line)
{
	char	c[3] = {0,0,0},str[6];
	int		i,pos,cr;
	float	sx,bx,xsx,xbx,wx;
	long	corStr[5],corBak[2],selPos1=0,selPos2=0,selPos3;

	if (gTSel[0].rno!=-1){
		selPos1 = gTSel[0].line * gLineLen + gTSel[0].cxr;
		selPos2 = gTSel[1].line * gLineLen + gTSel[1].cxr;
		if (selPos1>selPos2){											// selPos1selPos2܂łI͈
			selPos3 = selPos2;
			selPos2 = selPos1;
			selPos1 = selPos3;
		}
	}
	cr = 0;
	if (gFHeight>13) cr = 4;											// 16hbgtHg̓L
	pos = 0;
	sx = 0;
	bx = 0;
	selPos3 = line * gLineLen;
	ImgMove( LWIDTH,TBY+y*gFHeight,480-LWIDTH,gFHeight, 0,272*2.5 );	// sȍ~C[WҔ
	corBak[0] = gCor[2];												// ʏ핶wi
	if (gXShift==0){													// ʍ[ɎcS~̍폜
		wx = gFWidth;
		if (wx>gXDraw) wx = gXDraw;
		Fill( 0, TBY+y*gFHeight, wx, gFHeight, corBak[0] );
	}
	while (gText[rno]->len){
		if (gTSel[0].rno==-1 || selPos3<selPos1 || selPos3>=selPos2){
			corStr[0] = gCor[3];										// ʏ핶
			corStr[1] = gCor[11];										// Sp
			corStr[2] = gCor[10];										// Rg[R[h
			corStr[3] = gCor[8];										// s
			corStr[4] = gCor[7];										// ^u
			corBak[0] = gCor[2];										// ʏ핶wi
			corBak[1] = gCor[2];										// swi
		} else {														// eLXgI̐Fw
			corStr[0] = gCor[2];										// ʏ핶
			corStr[1] = gCor[2];										// Sp
			corStr[2] = gCor[2];										// Rg[R[h
			corStr[3] = gCor[2];										// s
			corStr[4] = gCor[2];										// ^u
			corBak[0] = gCor[3];										// ʏ핶wi
			corBak[1] = gCor[8];										// swi
		}
		c[0] = gText[rno]->text[pos++];
		selPos3++;
		xbx = bx - gXOffset;
		xsx = sx - gXOffset;
		if (c[0]=='\t'){												// ^u
			sx = GetTabPos(sx);											// ̃^uʒu
			xsx = sx - gXOffset;
			if (xbx<gXShift && xsx>=gXShift){
				Fill( gXShift, TBY+y*gFHeight, xsx-gXShift, gFHeight, corBak[0] );
			}else {
				if (xbx>=0 && xsx>gXDraw){								// ^uʂ͂ݏoꍇ
					Fill( xbx, TBY+y*gFHeight, gXDraw-xbx, gFHeight, corBak[0] );
				} else if (xbx>=gXShift && xsx>=gXShift){
					Fill( xbx, TBY+y*gFHeight, xsx-xbx, gFHeight, corBak[0] );
				}
			}
			if (gPTab){
				if (xbx>=gXShift || (gXShift>3 && xbx>=gXShift-3)){		// 3̓^u}[N̕iXN[ƂɃ}[NԂ̂Łj
					DrawChar( xbx, TBY+y*gFHeight+2, 0+cr, corStr[4] );
				}
			}
		} else if (c[0]=='\n'){											// s
			if (xsx<gXDraw && xsx>=gXShift){
				Fill( xsx, TBY+y*gFHeight, 6+1, gFHeight, corBak[1] );	// wi
				DrawChar( xsx, TBY+y*gFHeight+2, 1+cr, corStr[3] );
			}
			sx += 6;
		} else if (c[0]==0x1A){											// EOFi\Ȃj
		} else if ((unsigned char)c[0]<32){								// ̑̃Rg[R[h𔭌
			wx = GetStrWidth(gFont," ");
			if (xsx>=gXShift){
				Fill( xsx, TBY+y*gFHeight, wx, gFHeight, corBak[0] );	// wi
				Fill( xsx, TBY+y*gFHeight, wx-1, gFHeight-1, corStr[2] );
			}
			sx += wx;
		} else if (chkSJIS(c[0])){										// Sp
			c[1] = gText[rno]->text[pos++];
			wx = GetStrWidth(gFont,c);
			if (xsx>=gXShift){
				Fill( xsx, TBY+y*gFHeight, wx+0.5, gFHeight, corBak[0] );	// wi
			}
			selPos3++;
			if (strcmp(c,"@")==0 && gPSpc){							// Sp
				if (xsx>=gXShift){
					DrawChar( xsx+0, TBY+y*gFHeight+2, 2+cr, corStr[1] );
					DrawChar( xsx+5, TBY+y*gFHeight+2, 3+cr, corStr[1] );
				}
			} else {													// ̑̕
				if (xsx>=gXShift){
					pf_print( xsx, TBY+y*gFHeight, c, corStr[0] );
				}
			}
			c[1] = '\0';
			sx += wx;
		} else {														// p
			wx = GetStrWidth(gFont,c);
			if (xsx>=gXShift){
				Fill( xsx, TBY+y*gFHeight, wx+0.5, gFHeight, corBak[0] );	// wi
				pf_print( xsx, TBY+y*gFHeight, c, corStr[0] );
			}
			sx += wx;
		}
		bx = sx;
		if (gText[rno]->len<=pos || sx-gXOffset>=gXDraw){				// \I
			break;
		}
	}
	if (gText[rno]->chainNext==0xFFFFFFFF && gText[rno]->len<=pos){		// ŏIsȂ[EOF]ƕ\
		strcpy( str,"[EOF]" );
		for (i=0; i<5 ;i++){
			xsx = sx - gXOffset;
			c[0] = str[i];
			wx = GetStrWidth( gFont,c );
			if (xsx>=gXShift && xsx<LWIDTH){
				Fill( xsx, TBY+y*gFHeight, wx+1, gFHeight, gCor[2] );	// wi
				pf_print( xsx, TBY+y*gFHeight, c, gCor[9] );
			}
			sx += wx;
		}
	}

	xsx = sx - gXOffset;
	if (xsx<gXDraw){													// sȍ~̗]
		if (xsx>=gXShift){
			Fill( xsx, TBY+y*gFHeight, (gXDraw-(xsx-0.9f)), gFHeight, gCor[2] );
		} else {
			Fill( gXShift, TBY+y*gFHeight, gXDraw-gXShift, gFHeight, gCor[2] );
		}
	} else if (xsx>=LWIDTH){												// ʂ͂ݏoꍇ̏C
		ImgMove( 0,272*2.5,480-LWIDTH,gFHeight, LWIDTH,TBY+y*gFHeight );	// ҔĂsȍ~C[W𕜌
	}
}

void DrawRecLine(int y,long rno)
{
	DrawRecLine2( y, rno, GetLine(rno) );
}


//==============================================================
// wʒũR[heʂɕ\
//--------------------------------------------------------------

void DrawRec(int y,long rno)
{
	if (rno!=0xFFFFFFFF){
		DrawRecLine( y, rno );
	} else {
		Fill( 0, TBY+y*gFHeight, LWIDTH, gFHeight, gCor[2] );	// ŏIsȍ~
	}
}

//==============================================================
// ʑŜ̃R[he\
//--------------------------------------------------------------

void DrawFullRec2(long rno,long pline)
{
	int		i,l;

	l = 0;
	for (i=0; i<gSLine ;i++){
		l++;
		DrawRecLine2( i, rno, pline++ );
		rno = gText[rno]->chainNext;
		if (rno==0xFFFFFFFF) break;
	}
	if (l<gSLine || !gReDraw){									// ʉăS~폜
		Fill( 0, TBY+l*gFHeight, LWIDTH, 272-(TBY+l*gFHeight), gCor[2] );
	}
}

void DrawFullRec(long pline)
{
	DrawFullRec2(GetRNo(pline),pline);
}

//==============================================================
// XN[_E
//--------------------------------------------------------------
// ws牺sXN[_EB
// XN[̌ʊJꏊ̍XV͂ł͍sȂB
// GUɏĂ܂B
// ꔭœ]ɂ͉]ȂƂȂ̂AȎw͂łȂ
// ۂ̂ŁAxobt@ɓ]ĂړIʒuɕ`߂Ă܂B
//--------------------------------------------------------------

void RollDown(int y)
{
	int		wy;

	if (y==gSLine-1) return;

	wy = (gSLine-1-y) * gFHeight;
	sceGuStart( GU_DIRECT, gList );
	sceGuCopyImage( GU_PSM_8888, 0, TBY+y*gFHeight, LWIDTH, wy, 512, VRAM, 0,            272*2.5, 512, VRAM );
	sceGuCopyImage( GU_PSM_8888, 0,        272*2.5, LWIDTH, wy, 512, VRAM, 0, TBY+(y+1)*gFHeight, 512, VRAM );
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// XN[Abv
//--------------------------------------------------------------
// ws牺XN[AbvB
// XN[̌ʊJꏊ̍XV͂ł͍sȂB
// GUɏĂ܂B
// ͂̂܂ܑfɏĂ܂B
//--------------------------------------------------------------

void RollUp(int y)
{
	ImgMove(0, TBY+y*gFHeight+gFHeight, LWIDTH, (gSLine-1-y)*gFHeight, 0, TBY+y*gFHeight);
}

//==============================================================
// XN[Cg
//--------------------------------------------------------------
// ʂEɃXN[B
// XN[̌ʊJꏊ̍XV͂ł͍sȂB
// GUɏĂ܂B
// ꔭł͓]łȂ̂ŁAxobt@ɓ]ĂړIʒuɕ`߂Ă܂B
// xCPUŏĂ݂ǁAςGU̕B
// CPUʍGUʍ*2̂̕ˁB
//--------------------------------------------------------------

void RollRight(int wx)
{
	sceGuStart( GU_DIRECT, gList );
	sceGuCopyImage( GU_PSM_8888, 0, TBY, LWIDTH-wx, 272-TBY, 512, VRAM, 0, 272*2.5, 512, VRAM );
	sceGuCopyImage( GU_PSM_8888, 0, 272*2.5, LWIDTH-wx, 272-TBY, 512, VRAM, wx, TBY, 512, VRAM );
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// XN[tg
//--------------------------------------------------------------
// ʂɃXN[B
// XN[̌ʊJꏊ̍XV͂ł͍sȂB
// GUɏĂ܂B
//--------------------------------------------------------------

void RollLeft(int wx)
{
	ImgMove( wx, TBY, LWIDTH-wx, 272-TBY, 0, TBY );
}

//==============================================================
// w蕨ʒuzȂłƂ߂J[\ʒu
//--------------------------------------------------------------
// cx   J[\ʒu
// sx   hbgPʂł̃J[\ʒu
// cxr  _J[\ʒu
// cxb  ڕWJ[\ʒu
// rno  sR[h
// flag s̈i0:sEo ȊO:\I[ʒu܂ňړj
//--------------------------------------------------------------
// cxbɍł߂ʒucx,sx,cxrZbgB
// VtgJISł͑Sp𐳂邽߂ɂ͍sSpp`FbN
// Ă@܂B
// flag͉ʕ\ɔJ[\ړpi1jAClipRec()ɂspi0j
// ̎ʗpłB
//--------------------------------------------------------------

void CMSetSub(int *cx,float *sx,int *cxr,float cxb,char *text,int len,long rno,int flag)
{
	char	c[3] = {0,0,0};
	int		stepp,stepr;
	float	stepw;

	*cx = 0;
	*sx = 0;
	*cxr = 0;
	if (len==0) return;

	while (1){
		if (chkSJIS(text[*cxr])){
			stepr = 2;
			stepp = 2;
			c[0] = text[(*cxr)+0];
			c[1] = text[(*cxr)+1];
			stepw = GetStrWidth( gFont,c );
		} else if (text[*cxr]=='\t'){
			stepr = 1;
			if (gTab){
				stepp = (((*cx) + 8) & 0xFF8) - (*cx);			// TAB=8
			} else {
				stepp = (((*cx) + 4) & 0xFFC) - (*cx);			// TAB=4
			}
			stepw = GetTabPos(*sx) - (*sx);
		} else if (flag && text[*cxr]=='\n'){
			break;
		} else {
			stepr = 1;
			stepp = 1;
			c[0] = text[(*cxr)+0];
			c[1] = '\0';
			stepw = GetStrWidth( gFont,c );
		}
		if (flag || text[*cxr]!='\t'){
			if ((*sx)+stepw>=cxb) break;						// w|CgɒB
		} else {												// ^usEɗꍇ̗O
			if ((*sx)+2>=cxb) break;							// ^u̍ŏ2hbg
		}
		(*cx) += stepp;
		(*sx) += stepw;
		(*cxr) += stepr;
		if (*cxr>=len){											// sŌɒB
			if (flag && gText[rno]->chainNext!=0xFFFFFFFF){
				(*cx) -= stepp;
				(*sx) -= stepw;
				(*cxr) -= stepr;
			}
			break;
		}
	}
}

void CMSet(int *cx,float *sx,int *cxr,float cxb,long rno,int flag)
{
	CMSetSub( cx, sx, cxr, cxb, gText[rno]->text, gText[rno]->len, rno, flag );
}

//==============================================================
// J[\_ʒuɈړ
//--------------------------------------------------------------
// cs.cxr w_ʒu
//--------------------------------------------------------------
// cxrŎw肳ꂽ_ʒuɍ悤cx,sx,cxbݒ肷B
// cxbsxƓlɂȂ܂B
// sOꂽʒuw肳Ăꍇ͍sʒuɐݒ肳܂B
// ̏ꍇAcxrsʒuւƕύX܂B
//--------------------------------------------------------------

void CRSet(struct strCsrSts *cs)
{
	char	c[3] = {0,0,0};
	int		pos,stepp,stepr;
	float	stepw;

	(cs->cx) = 0;
	(cs->sx) = 0;
	pos = 0;
	if (gText[cs->rno]->len==0){
		(cs->cxr) = 0;
		(cs->cxb) = 0;
		return;
	}

	while (pos<(cs->cxr)){
		if (chkSJIS(gText[cs->rno]->text[pos])){
			stepr = 2;
			stepp = 2;
			c[0] = gText[cs->rno]->text[pos+0];
			c[1] = gText[cs->rno]->text[pos+1];
			stepw = GetStrWidth( gFont,c );
		} else if (gText[cs->rno]->text[pos]=='\t'){
			stepr = 1;
			if (gTab){
				stepp = (((cs->cx) + 8) & 0xFF8) - (cs->cx);	// TAB=8
			} else {
				stepp = (((cs->cx) + 4) & 0xFFC) - (cs->cx);	// TAB=4
			}
			stepw = GetTabPos(cs->sx) - (cs->sx);
		} else if (gText[cs->rno]->text[pos]=='\n'){
			break;
		} else {
			stepr = 1;
			stepp = 1;
			c[0] = gText[cs->rno]->text[pos+0];
			c[1] = '\0';
			stepw = GetStrWidth( gFont,c );
		}
		(cs->cx) += stepp;
		(cs->sx) += stepw;
		pos += stepr;
		if (pos>=gText[cs->rno]->len) break;					// sɒB
	}

	(cs->cxr) = pos;
	(cs->cxb) = (cs->sx);
}

//==============================================================
// J[\Ɉړ
//--------------------------------------------------------------
// flag s̈i0:sEo ȊO:\I[ʒu܂ňړj
//--------------------------------------------------------------
// O̍sŁAcxb̕ʒuɂƂ߂ʒuɃJ[\ړB
// Kvɉĉʂ̃XN[sB
//--------------------------------------------------------------

void CMUp(struct strCsrSts *cs,int flag)
{
	long	bufRNo;

	if (gText[cs->rno]->chainBack==0xFFFFFFFE) return;			// 擪sȂ牽Ȃ
	bufRNo = cs->rno;
	cs->rno = gText[cs->rno]->chainBack;
	if (gText[cs->rno]->enter) (cs->rline)--;					// J[\ʒu̘_s
	CMSet( &cs->cx, &cs->sx, &cs->cxr, (cs->cxb)+1, cs->rno, flag );	// J[\ʒu̕␳
	gTSel[1].rno = cs->rno;										// eLXg͈͎wp
	gTSel[1].cxr = cs->cxr;
	gTSel[1].line = cs->pline + cs->cy -1;
	if (gTSel[0].rno!=-1 && flag){								// eLXg͈͎w蒆Ȃ
		DrawRec( (cs->cy),bufRNo );								// ړÕJ[\s\XV
	}

	(cs->cy)--;
	if (cs->cy<0){												// J[\ʂ͂ݏoȂXN[
		cs->cy = 0;
		(cs->pline)--;
		if (flag){
			RollDown(0);
			DrawRec( (cs->cy),(cs->rno) );
		}
	} else if (gTSel[0].rno!=-1){								// eLXg͈͎w蒆Ȃ
		DrawRec( (cs->cy),(cs->rno) );							// ړ̃J[\s\XV
	}
}

//==============================================================
// J[\Ɉړ
//--------------------------------------------------------------
// ̍sŁAcxb̕ʒuɂƂ߂ʒuɃJ[\ړB
// Kvɉĉʂ̃XN[sB
//--------------------------------------------------------------

void CMDown(struct strCsrSts *cs,int flag)
{
	long	bufRNo;

	if (gText[cs->rno]->chainNext==0xFFFFFFFF){							// ŏIsȂ
		CMSet( &cs->cx, &cs->sx, &cs->cxr, (cs->cxb)+1, cs->rno, 0 );	// J[\ʒu̕␳
		if (gTSel[0].rno!=-1){											// eLXg͈͎w蒆Ȃ
			gTSel[1].rno = cs->rno;										// eLXg͈͎wp
			gTSel[1].cxr = cs->cxr;
			gTSel[1].line = cs->pline + cs->cy;
			if (flag)
				DrawRec( cs->cy, cs->rno );								// ŏIs̕\XV
		}
		return;
	}

	bufRNo = cs->rno;
	if (gText[cs->rno]->enter) (cs->rline)++;							// J[\ʒu̘_s
	cs->rno = gText[cs->rno]->chainNext;								// ̍sɑΉĂ郌R[h
	if (gText[cs->rno]->chainNext==0xFFFFFFFF){							// ŏIsȂ
		CMSet( &cs->cx, &cs->sx, &cs->cxr, (cs->cxb)+1, cs->rno, 0 );	// J[\ʒu̕␳iŏIsŏIzj
	} else {
		CMSet( &cs->cx, &cs->sx, &cs->cxr, (cs->cxb)+1, cs->rno, 1 );	// J[\ʒu̕␳
	}
	gTSel[1].rno = cs->rno;												// eLXg͈͎wp
	gTSel[1].cxr = cs->cxr;
	gTSel[1].line = cs->pline + cs->cy +1;
	if (gTSel[0].rno!=-1 && flag){										// eLXg͈͎w蒆Ȃ
		DrawRec( cs->cy, bufRNo );										// ړÕJ[\s\XV
	}

	(cs->cy)++;
	if (cs->cy>=gSLine-gReDraw){										// J[\ʂ͂ݏoȂXN[
		cs->cy = gSLine-1-gReDraw;
		(cs->pline)++;
		if (flag){
			RollUp(0);
			if (gReDraw){
				DrawRec( gSLine-2, ShiftRNo(cs->rno,gSLine-2-(cs->cy)) );
			}
			DrawRec( gSLine-1, ShiftRNo(cs->rno,gSLine-1-(cs->cy)) );
		}
	}else if (gTSel[0].rno!=-1 && flag){								// eLXg͈͎w蒆Ȃ
		DrawRec( cs->cy, cs->rno );										// ړ̃J[\s\XV
	}
}

//==============================================================
// J[\EɈړ
//--------------------------------------------------------------

void CMRight(struct strCsrSts *cs,int flag)
{
	char	c[3] = {0,0,0};

	if (chkSJIS(gText[cs->rno]->text[cs->cxr])){
		c[0] = gText[cs->rno]->text[(cs->cxr)+0];
		c[1] = gText[cs->rno]->text[(cs->cxr)+1];
		(cs->cxr) += 2;
		(cs->cx) += 2;
		(cs->sx) += GetStrWidth( gFont,c );
	} else if (gText[cs->rno]->text[cs->cxr]=='\t'){
		(cs->cxr)++;
		if (gTab){
			(cs->cx) = ((cs->cx) + 8) & 0xFF8;					// TAB=8
		} else {
			(cs->cx) = ((cs->cx) + 4) & 0xFFC;					// TAB=4
		}
		(cs->sx) = GetTabPos(cs->sx);
	} else if (gText[cs->rno]->text[cs->cxr]=='\n'){
		(cs->cxb) = 0;
		(cs->sx) = 0;
		CMDown( cs,flag );
	} else {
		c[0] = gText[cs->rno]->text[(cs->cxr)+0];
		c[1] = '\0';
		(cs->cxr)++;
		(cs->cx)++;
		(cs->sx) += GetStrWidth( gFont,c );
	}
	if ((cs->cxr)>=gText[cs->rno]->len){						// s̍Ōz
		if (gText[cs->rno]->chainNext!=0xFFFFFFFF){
			(cs->cxb) = 0;
			(cs->sx) = 0;
		} else {												// ŏIsŏIz
			(cs->cxb) = (gRoll ? WWIDTH : LWIDTH);
		}
		CMDown( cs,flag );
	}
	(cs->cxb) = cs->sx;

	gTSel[1].rno = cs->rno;										// eLXg͈͎wp
	gTSel[1].cxr = cs->cxr;
	gTSel[1].line = cs->pline + cs->cy;
	if (gTSel[0].rno!=-1 && flag){								// eLXg͈͎w蒆Ȃ
		DrawRec( cs->cy, cs->rno );								// ړÕJ[\s\XV
	}
}

//==============================================================
// J[\Ɉړ
//--------------------------------------------------------------

void CMLeft(struct strCsrSts *cs,int flag)
{
	if (cs->cx==0){
		if (gText[cs->rno]->chainBack!=0xFFFFFFFE){					// sڈȍ~̂Pځisڂł͉Ȃj
			cs->cxb = (gRoll ? WWIDTH : LWIDTH);					// sڕW
			CMUp( cs, flag );
		}
	} else {
		cs->cxb = cs->sx;
		CMSet( &cs->cx, &cs->sx, &cs->cxr, cs->cxb, cs->rno, 1 );	// J[\ʒu̕␳
		gTSel[1].rno = cs->rno;										// eLXg͈͎wp
		gTSel[1].cxr = cs->cxr;
		gTSel[1].line = cs->pline + cs->cy;
		if (flag && gTSel[0].rno!=-1){								// eLXg͈͎w蒆Ȃ
			DrawRec( cs->cy, cs->rno );								// ړÕJ[\s\XV
		}
	}
	cs->cxb = cs->sx;
}

//==============================================================
// sR[h̕␳
//--------------------------------------------------------------
// cy     ␳Jnsʒuiʏł̈ʒuj
// pline  ʍŏʈʒuɑΉ镨s
// rno    ␳Jn郌R[h
// flag   ␳ɔʕ\si0:\Ȃ(Rsyp) ȊO:\j
// ߂l  0:I
//        -1:sR[h̎擾łȂ
//--------------------------------------------------------------
// sR[hɕǉ/폜sωꍇȂǂɍsR[h̒̕␳sB
// ʂ̍XVɍs܂B
// ݂̍sR[hƎ̍sR[hqŉ߂ĉʏłPsɂȂ悤
// sR[h𕪊B
// ȉAsĂJԂB
// VsR[hKvɂȂǉAsvƂȂsR[h͍폜B
// VsR[h擾oȂꍇAVsɌJz\肾͎܂B
//--------------------------------------------------------------

int ClipRec(int cy,long pline,long rno,int flag)
{
	char	tmp[(WWIDTH/2+2)*2+8];									// s+^u
	int		err,cx,cxr,len,cyBak;
	long	i,rno2,lCnt,rnoBak;
	float	sx;

	//----- s -----

	cyBak = cy;
	rnoBak = rno;
	lCnt = 0;
	err = 0;
	rno2 = 0xFFFFFFFF;
	len = 0;
	while (1){
		if (len==0){
			len = gText[rno]->len;
			memcpy( tmp, gText[rno]->text, len );
			if (gText[rno]->next){								// ̍sɑĂꍇ
				rno2 = gText[rno]->chainNext;
				len += gText[rno2]->len;
				memcpy( &tmp[gText[rno]->len], gText[rno2]->text, gText[rno2]->len );
				gText[rno2]->len = 0;
			}
		}
		CMSetSub( &cx, &sx, &cxr, (gRoll ? WWIDTH : LWIDTH), tmp, len, rno, 0 );	// ʏłPsƂȂʒu𒲂ׂ
		if (AddRecText( rno,cxr )){								// {̈̊gɎsH
			gText[rno]->text[gText[rno]->len] = '\n';
			gText[rno]->next = 0;								// ̍s֑Ȃ
			gText[rno]->enter = 1;								// s
			err = -1;
			break;												// ُIisR[h擾łȂj
		}
		memcpy( gText[rno]->text, tmp, cxr );
		gText[rno]->text[cxr] = '\0';							// [EOF]O̍sɈړۂɃS~cĤȁHH
		gText[rno]->len = cxr;									// sڂ̃R[h
		len -= cxr;
		if (len){												// ̍sɑꍇ
			memcpy( tmp, &tmp[cxr], len );
			if (cy<gSLine && flag)
				DrawRec( cy, rno );								// \XV
			CMSetSub( &cx, &sx, &cxr, (gRoll ? WWIDTH : LWIDTH), tmp, len, rno, 0 );
			if (len!=cxr){										// ܂肪sȏ゠̂ŐVsǉ
				rno2 = GetNewRec(TEXTBLSIZE);
				if (rno2!=-1){									// VsR[h擾łȂ
					gText[rno2]->back = 1;
					gText[rno2]->next = 1;
					gText[rno2]->enter = gText[rno]->enter;
					gText[rno2]->chainNext = gText[rno]->chainNext;
					gText[rno2]->chainBack = rno;				// Xg`FC̐ڑ
					gText[rno]->next = 1;						// ̍s֑
					gText[rno]->enter = 0;						// s݂͑Ȃ
					gText[rno]->chainNext = rno2;
					if (gText[rno2]->chainNext!=0xFFFFFFFF){
						gText[gText[rno2]->chainNext]->chainBack = rno2;
					}
					lCnt++;
				} else {										// sR[h擾łȂII
					CMSet( &cx, &sx, &cxr, (gRoll ? WWIDTH : LWIDTH), rno, 0 );
					gText[rno]->text[cxr] = '\n';
					gText[rno]->next = 0;						// ̍s֑Ȃ
					gText[rno]->enter = 1;						// s
					err = -1;
					break;										// ُIisR[h擾łȂj
				}
			} else {											// ܂肪sȉ
				if (gText[rno]->next){							// ̍sȂq
					while (1){
						rno2 = gText[rno]->chainNext;
						memcpy( &tmp[len], gText[rno2]->text, gText[rno2]->len );
						len += gText[rno2]->len;
						CMSetSub( &cx, &sx, &cxr, (gRoll ? WWIDTH : LWIDTH), tmp, len, rno2, 0 );
						if (len!=cxr || !gText[rno2]->next) break;
						gText[rno]->enter = gText[rno2]->enter;	// qłsɖȂȂ獡̍sR[h͍폜
						gText[rno]->next = gText[rno2]->next;
						gText[rno]->chainNext = gText[rno2]->chainNext;
						if (gText[rno]->chainNext!=0xFFFFFFFF)
							gText[gText[rno]->chainNext]->chainBack = rno;
						DelRec(rno2);							// svɂȂsR[h폜
						lCnt--;
					}
				} else {										// ̍sȂV쐬
					rno2 = GetNewRec(TEXTBLSIZE);
					if (rno2!=-1){								// VsR[h擾łȂ
						gText[rno2]->back = 1;
						gText[rno2]->next = 0;
						gText[rno2]->enter = gText[rno]->enter;
						gText[rno2]->chainNext = gText[rno]->chainNext;
						gText[rno2]->chainBack = rno;			// Xg`FC̐ڑ
						gText[rno]->next = 1;					// ̍s֑
						gText[rno]->enter = 0;					// s݂͑Ȃ
						gText[rno]->chainNext = rno2;
						if (gText[rno2]->chainNext!=0xFFFFFFFF){
							gText[gText[rno2]->chainNext]->chainBack = rno2;
						}
						lCnt++;
					} else {									// sR[h擾łȂII
						CMSet( &cx, &sx, &cxr, (gRoll ? WWIDTH : LWIDTH), rno, 0 );
						gText[rno]->text[cxr] = '\n';
						gText[rno]->next = 0;					// ̍s֑Ȃ
						gText[rno]->enter = 1;					// s
						err = -1;
						break;									// ُIisR[h擾łȂj
					}
				}
			}
			rno = rno2;
			cy++;

		} else {												// ̍sɑꍇ
			if (gText[rno]->next){								// O͎̍ŝŁA̍s͍폜
				gText[rno]->enter = gText[rno2]->enter;
				gText[rno]->next = gText[rno2]->next;
				gText[rno]->chainNext = gText[rno2]->chainNext;
				if (gText[rno]->chainNext!=0xFFFFFFFF)
					gText[gText[rno]->chainNext]->chainBack = rno;
				DelRec(rno2);									// svɂȂsR[h폜
				lCnt--;
			}
			break;												// I
		}
	}

	//----- ʕ\XV -----

	cy = cyBak;
	rno = rnoBak;
	if (flag){
		if (lCnt<0){
			lCnt = -lCnt;
			if (cy+1<gSLine-1){
				for ( i=lCnt; i>0 ;i-- ){
					RollUp( cy+1 );
				}
				for ( i=lCnt; i>0 ;i--){
					DrawRec( gSLine-i, ShiftRNo(rno,gSLine-i-cy) );
				}
			} else if (cy+1==gSLine-1){
				DrawRec( gSLine-1,ShiftRNo(rno,gSLine-1-cy) );
			}
		} else if (lCnt>0){
			if (cy+1<gSLine)
				for ( i=lCnt; i>0 ;i-- )
					RollDown(cy+1);
		}
		while (cy<gSLine){
			DrawRec( cy++, rno );								// \XV
			if (!gText[rno]->next) break;
			rno = gText[rno]->chainNext;
		}
	}

	return (err);
}

//==============================================================
// J[\ʒuɉs}
//--------------------------------------------------------------
// VsR[h擾oȂꍇ͉-1ԂB
//--------------------------------------------------------------

int AddRet(struct strCsrSts *cs,int flag,int undoflag)
{
	char	c,buf[(WWIDTH/2+2)*2];
	int		i,pos,len,cyBak;
	long	rno2,rno3;

	//----- VsR[h擾łH -----

	rno2 = GetNewRec(TEXTBLSIZE);
	if (rno2==-1) return (-1);									// VsR[h擾oȂꍇ
	DelRec(rno2);

	//----- }ʒuC -----

	if ((cs->cxr)==0 && gText[cs->rno]->back){					// O̍s̍Ōɒǉׂꍇ肤̂
		cs->cxb = (gRoll ? WWIDTH : LWIDTH);
		cyBak = cs->cy;
		CMUp( cs,0 );											// O̍s̍sɃJ[\ړ
		if (gText[cs->rno]->enter){								// ς莟̍s̐擪ɒǉ̂
			CMRight( cs,0 );
		} else if (cyBak==0){									// O̍sʊȌꍇ
			if (flag){
				RollDown(0);
				DrawRec( 0, cs->rno );
			}
		}
	}

	//----- 蒼 -----

	if (undoflag){
		gUndo[gUndoPos].pline = cs->pline + cs->cy;					// u蒼vf[^ۑ
		gUndo[gUndoPos].cxr = cs->cxr;
		gUndo[gUndoPos].str[0] = '\n';
		gUndo[gUndoPos].str[1] = 0;
		gUndo[gUndoPos].str[2] = 1;									// 
		gUndoPos++;
		if (gUndoPos>=UNDOSIZE) gUndoPos = 0;
		gUndoSize++;
		if (gUndoSize>=UNDOSIZE) gUndoSize = UNDOSIZE;
	}

	//----- sR[h̑} -----

	pos = 0;
	len = 0;
	for ( i=(cs->cxr); i<gText[cs->rno]->len ;i++ ){			// ̍sɑ镶obt@֑Ҕ
		buf[pos++] = gText[cs->rno]->text[i];
		len++;
	}

	if (!gText[cs->rno]->next){									// ̍sɑĂȂ
		rno2 = GetNewRec(TEXTBLSIZE);
		if (rno2!=-1){											// VsR[h擾łȂ
			if (AddRecText(rno2,len)){							// {̈̊gɎsH
				DelRec(rno2);									// mۂsR[hp
				if (undoflag){
					gUndoPos--;									// u蒼vf[^LZ
					if (gUndoPos<0) gUndoPos = UNDOSIZE;
					gUndoSize--;
				}
				return (-1);
			}
			gText[rno2]->back = 0;
			gText[rno2]->next = gText[cs->rno]->next;
			gText[rno2]->enter = gText[cs->rno]->enter;
			gText[rno2]->chainNext = gText[cs->rno]->chainNext;
			gText[rno2]->chainBack = cs->rno;					// Xg`FC̐ڑ
			gText[cs->rno]->next = 0;
			gText[cs->rno]->enter = 1;							// s
			gText[cs->rno]->chainNext = rno2;
			if (gText[rno2]->chainNext!=0xFFFFFFFF){
				gText[gText[rno2]->chainNext]->chainBack = rno2;
			}
			if ((cs->cy)+1<gSLine && flag){						// V쐬sʓȂ
				RollDown((cs->cy)+1);							// ǉs̃̕Xy[Xmہise̍XV͌ōsj
			}
		} else {												// sR[h擾łȂII
			if (undoflag){
				gUndoPos--;										// u蒼vf[^LZ
				if (gUndoPos<0) gUndoPos = UNDOSIZE;
				gUndoSize--;
			}
			return (-1);										// ɈُI
		}
		gText[cs->rno]->len = (cs->cxr)+1;
		gText[cs->rno]->text[cs->cxr] = '\n';
		gText[rno2]->len = len;
		memcpy( gText[rno2]->text, buf, len );
		if (flag){
			DrawRec( (cs->cy)+0, cs->rno );						// s
			if ((cs->cy)+1<gSLine){
				DrawRec( (cs->cy)+1, rno2    );					// s
			}
		}

	} else {													// s܂ԂĂꍇ
		gText[cs->rno]->len = (cs->cxr)+1;
		gText[cs->rno]->text[cs->cxr] = '\n';
		gText[cs->rno]->next = 0;
		gText[cs->rno]->enter = 1;								// s
		gText[gText[cs->rno]->chainNext]->back = 0;
		if (flag){
			DrawRec( cs->cy, cs->rno );							// s
		}
		rno2 = gText[cs->rno]->chainNext;
		while (1){												// obt@̍̕s֑}
			memcpy( &buf[len], gText[rno2]->text, gText[rno2]->len );
			len += gText[rno2]->len;
			pos = 0;
			while (pos<gLineLen-2 && pos<len){
				if (AddRecText(rno2,pos+2)){					// {̈̊gɎsH
					len = pos;									// obt@̕p
					break;										// f
				}
				c = buf[pos];
				if (chkSJIS(c)){
					gText[rno2]->text[pos++] = c;
					c = buf[pos];
				}
				gText[rno2]->text[pos++] = c;
			}
			gText[rno2]->len = pos;
			len -= pos;
			if (!len) break;									// ̍sɌJz񂪖Ȃ
			memcpy( buf, &buf[pos], len );
			if (gText[rno2]->next){								// ̍sȂ
				rno2 = gText[rno2]->chainNext;
			} else {											// ̍ŝŐV擾
				rno3 = GetNewRec(TEXTBLSIZE);
				if (rno3!=-1){									// VsR[h擾łȂ
					gText[rno3]->back = 1;
					gText[rno3]->next = gText[rno2]->next;
					gText[rno3]->enter = gText[rno2]->enter;
					gText[rno3]->chainNext = gText[rno2]->chainNext;
					gText[rno3]->chainBack = rno2;				// Xg`FC̐ڑ
					gText[rno2]->next = 1;
					gText[rno2]->enter = 0;						// sȂ
					gText[rno2]->chainNext = rno3;
					if (gText[rno3]->chainNext!=0xFFFFFFFF){
						gText[gText[rno3]->chainNext]->chainBack = rno3;
					}
					if ((cs->cy)+1<gSLine && flag){				// V쐬sʓȂ
						RollDown((cs->cy)+1);					// ǉs̃̕Xy[Xmہise̍XV͌ōsj
					}
					gText[rno3]->len = 0;
					rno2 = rno3;
				} else {										// sR[h擾łȂII
					gText[rno2]->text[gText[rno2]->len] = '\n';
					gText[rno2]->len++;
					break;										// obt@ɕ񂪎cĂ邪̂Ă邵Ȃ
				}
			}
		}
		ClipRec( (cs->cy)+1, cs->pline, gText[cs->rno]->chainNext, flag );
	}

	CMRight( cs,flag );											// J[\ꕶ
	return (0);
}

//==============================================================
// J[\ʒu̕폜
//--------------------------------------------------------------

void DelStr(struct strCsrSts *cs,int flag,int undoflag)
{
	int		i,step;

	if ((cs->cxr)>=gText[cs->rno]->len) return;					// J[\ʒu[EOF]̏ꍇ͍폜̎s͂łȂ

	if (gText[cs->rno]->text[cs->cxr]=='\n'){					// sR[h폜ꍇA̍sƓKv邪
		gText[cs->rno]->enter = 0;								// ł͍sR[h̐ݒ邾ŁA{̓
		gText[cs->rno]->next = 1;								// ClipRec()ɂď܂
		gText[gText[cs->rno]->chainNext]->back = 1;
	}

	if (chkSJIS(gText[cs->rno]->text[cs->cxr])){				// Spp
		step = 2;
	} else {
		step = 1;
	}
	if (undoflag){
		gUndo[gUndoPos].pline = cs->pline + cs->cy;				// u蒼vf[^ۑ
		gUndo[gUndoPos].cxr = cs->cxr;
		gUndo[gUndoPos].str[0] = gText[cs->rno]->text[cs->cxr];
		gUndo[gUndoPos].str[1] = (step==1 ? 0 : gText[cs->rno]->text[cs->cxr+1]);
		gUndo[gUndoPos].str[2] = 0;								// 폜
		gUndoPos++;
		if (gUndoPos>=UNDOSIZE) gUndoPos = 0;
		gUndoSize++;
		if (gUndoSize>=UNDOSIZE) gUndoSize = UNDOSIZE;
	}
	for (i=cs->cxr; i<gText[cs->rno]->len-1 ;i++)
		gText[cs->rno]->text[i] = gText[cs->rno]->text[i+step];
	gText[cs->rno]->len -= step;
	ClipRec( cs->cy, cs->pline, cs->rno, flag );				// sR[h̒̕␳
	if (gText[cs->rno]->chainBack!=0xFFFFFFFE || cs->cx!=0){	// sڂPڂł͂ȂꍇAJ[\ʒu␳
		CMLeft( cs,flag );
		CMRight( cs,flag );
	}
}

//==============================================================
// J[\ʒuɕǉ
//--------------------------------------------------------------
// ߂l  0:
//        -1:Ȃ
//--------------------------------------------------------------
// w肳ꂽ͂PǉĂ܂B
// ܂Ƃ߂ď肱̂ق菇z₷̂ŁB
//--------------------------------------------------------------

int AddStr(struct strCsrSts *cs,char *str,int flag,int undoflag)
{
	char	c[3] = {0,0,0};
	int		p,pos,len,step,err,mv;
	float	wc;

	mv = 0;
	err = 0;
	pos = 0;
	len = strlen(str);
	while (pos<len){
		if (chkSJIS(str[pos])){									// Spp
			step = 2;
			c[0] = str[pos+0];
			c[1] = str[pos+1];
			wc = GetStrWidth( gFont,c );
			if ((cs->sx)+wc>=(gRoll ? WWIDTH : LWIDTH)) mv = 1;
		} else {
			step = 1;
			if (cs->cxr==0 && gText[cs->rno]->back){			// O̍s̍Ōɒǉׂꍇ肤̂
				cs->cxb = (gRoll ? WWIDTH : LWIDTH);
				CMUp( cs,0 );									// O̍s̍sɃJ[\ړ
			}
			c[0] = str[pos];
			c[1] = '\0';
			wc = GetStrWidth( gFont,c );
			if ((cs->sx)+wc>=(gRoll ? WWIDTH : LWIDTH)) mv = 1;	// J[\ʒu␳
		}
		if (str[pos]=='\n'){
			if (AddRet( cs,flag,undoflag )){					// Ȃ
				err = -1;
				break;
			}
			pos++;
		} else {
			if (AddRecText(cs->rno,gText[cs->rno]->len+step)){	// {̈̊gɎsH
				err = -1;
				break;
			}
			p = gText[cs->rno]->len;
			if (p!=0){											// ǉXy[Xm
				do {
					p--;
					gText[cs->rno]->text[p+step] = gText[cs->rno]->text[p];
				} while (p>(cs->cxr));
			}
			memcpy( &gText[cs->rno]->text[cs->cxr], &str[pos], step );	// ǉ
			gText[cs->rno]->len += step;
			pos += step;
			if (undoflag){
				gUndo[gUndoPos].pline = cs->pline + cs->cy;		// u蒼vf[^ۑ
				gUndo[gUndoPos].cxr = cs->cxr;
				gUndo[gUndoPos].str[0] = c[0];
				gUndo[gUndoPos].str[1] = c[1];
				gUndo[gUndoPos].str[2] = 1;						// 
				gUndoPos++;
				if (gUndoPos>=UNDOSIZE) gUndoPos = 0;
				gUndoSize++;
				if (gUndoSize>=UNDOSIZE) gUndoSize = UNDOSIZE;
			}
			err = ClipRec( cs->cy, cs->pline, cs->rno, flag );	// sR[h̒̕␳
			if (err) break;										// sR[h擾łȂȂ珈𒆒f
			CMRight( cs,flag );									// J[\ꕶ
			if (mv){
				CMRight( cs,flag );								// J[\ʒu␳
			}
		}
		mv = 0;
	}
	return (err);
}

//==============================================================
// J[\wsʒuɈړ
//--------------------------------------------------------------
// cs    J[\
// pline ړsʒu
//--------------------------------------------------------------
// wsʒuʒɗ悤ɃJ[\CB
// Ĉ́A
//     cs->cy
//     cs->rno
//     cs->pline
//     cs->rline
// łB
//--------------------------------------------------------------

void SetCursor(struct strCsrSts *cs,long pline)
{
	long	rno,line,rline;

	if (pline>gLineMax) pline = gLineMax;
	if (gLineMax<gSLine+1+gReDraw){									// SʓɎ܂ꍇ
		cs->cy = pline;
		pline = 0;
	} else {
		if (pline<gSLine/2-2){
			cs->cy = pline;
			pline = 0;
		} else {
			cs->cy = gSLine / 2 -2;
			pline -= gSLine / 2 -2;
		}
		if (pline>gLineMax-gSLine+1+gReDraw){						// ͂̏Ïʓȏꍇ
			cs->cy = pline + cs->cy - (gLineMax-gSLine+1+gReDraw);
			pline = gLineMax - gSLine+1 + gReDraw;
		}
	}
	cs->pline = pline;												// O̘_sʒuɉʂZbg

	rno = 0;
	rline = 0;
	line = 0;
	while (line!=pline+cs->cy && rno!=0xFFFFFFFF){					// w蕨sʒuT
		if (gText[rno]->enter) rline++;
		line++;
		rno = gText[rno]->chainNext;
	};
	cs->rno = rno;
	cs->rline = rline;
}

//==============================================================
// ʈʒu𕶎J[\\ʒuɕύX
//--------------------------------------------------------------

void ScreenAdj(struct strCsrSts *cs)
{
	if (cs->sx<gXOffset+20){
		if (gXOffset!=0){
			gXOffset = cs->sx - 60;
			if (gXOffset<0) gXOffset = 0;
		}
	} else if (gXOffset+LWIDTH-20<cs->sx){
		if (gXOffset+LWIDTH<WWIDTH){
			gXOffset = cs->sx - LWIDTH + 60;
			if (gXOffset+LWIDTH>WWIDTH) gXOffset = WWIDTH - LWIDTH;
		}
	}
}

//==============================================================
// j[iYes/NomF_CAOj
//--------------------------------------------------------------
// msg   FbZ[Wisj
// ߂lF1 ꂽ
//         0 ȊO
//--------------------------------------------------------------
// bZ[WɁu:Yes  ~:Novǉœ͏s܂B
//--------------------------------------------------------------

int MenuDLGyn(char *msg,long corFrm,long corIn)
{
	SceCtrlData		pad;
	int				ret;

	DiaBox2( -1, 104, 0, msg, ":Yes  ~:No", gSCor[0], gSCor[13], corFrm, corIn );	// ɕ\
	Unpush();													// {^܂őҋ@
	ret = 0;
	ScreenView();												// ʍXV
	while (!gExitRequest){										// ~܂őҋ@
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		if (ret==SIME_KEY_CIRCLE || ret==SIME_KEY_CROSS) break;
		sceDisplayWaitVblankStart();
	}
	if (ret==SIME_KEY_CIRCLE){
		ret = 1;
	} else {
		ret = 0;
	}
	return (ret);
}

//==============================================================
// j[ieLXg̕ۑj
//--------------------------------------------------------------

int MenuSave(char *filepath)
{
	char			msg[128];
	int				ret;

	ret = filesave(filepath);
	if (ret==-1){
		strcpy( msg, "[Nmۂł܂łB" );
	} else if (ret==-2){
		strcpy( msg, "t@CŃG[܂B\n(" );
		strcat( msg, filepath );
		strcat( msg, ")\n" );
	} else if (ret==1){
		
	}
	if (ret){
		strcat( msg, "\neLXg͕ۑĂ܂B" );
		DiaBox1( -1, 120, 0, msg, gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
		Unpush();												// {^܂őҋ@
		WaitBtn();												// ܂őҋ@
		return (-2);											// G[
	}
	return (0);													// ۑ
}

//==============================================================
// j[it@C̕ۑj
//--------------------------------------------------------------

void MenuLoad(char *filepath)
{
	char	msg[128];
	int		ret;

	ret = fileload(filepath);
	if (ret==1 || ret==-3){
		switch (ret){
		case 2:
			strcpy( msg,"ǂݍ݂LZ܂B" );
			break;
		case 1:
			strcpy( msg,"ȂȂ̂ŕ͂̓ǂݍ݂𒆒f܂B" );
			break;
		}
		DiaBox1( -1, 120, 0, msg, gSCor[0], gSCor[3], gSCor[4] );
		Unpush();												// {^܂őҋ@
		WaitBtn();												// ܂őҋ@
	}
}

//==============================================================
// j[ieLXg̃y[Xgj
//--------------------------------------------------------------
// Ɏ荞܂ĂeLXgJ[\ʒuɓ\t܂B
//--------------------------------------------------------------

void TextPaste(struct strCsrSts *cs)
{
	if (gTextClip==NULL) return;

	if (strlen(gTextClip)){										// y[Xg镶Ȃ
		if (AddStr( cs, gTextClip, 0, 1 )){
			DiaBox1( -1, 120, 0, "ȂȂ܂B", gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
			Unpush();												// {^܂őҋ@
			WaitBtn();												// ܂őҋ@
		}
		gSave = 1;
	}
}

//==============================================================
// j[ieLXg̃Rs[j
//--------------------------------------------------------------
// gTSel[0]`gTSel[1]͈̔͂̃eLXg荞݂܂B
// ͈͎w肪LȏԂŎs邱ƁB
// ŏ̎_ł[0][1]̂ǂ炪擪Ȃ̂ŒӁB
// 荞܂ꂽeLXggTextClipɕۊǂ܂B
//--------------------------------------------------------------

char* TextCapture(void)
{
	char	*buf;
	int		cxr,cxrEnd;
	long	rno,rnoEnd,pos,pos0,pos1,size;

	pos0 = gTSel[0].line * gLineLen + gTSel[0].cxr;
	pos1 = gTSel[1].line * gLineLen + gTSel[1].cxr;
	if (pos0>pos1){												// ̊JnʒuƏIʒu
		rno = gTSel[1].rno;
		cxr = gTSel[1].cxr;
		rnoEnd = gTSel[0].rno;
		cxrEnd = gTSel[0].cxr;
	} else {
		rno = gTSel[0].rno;
		cxr = gTSel[0].cxr;
		rnoEnd = gTSel[1].rno;
		cxrEnd = gTSel[1].cxr;
	}

	size = (GetLine(rnoEnd) - GetLine(rno) +1) * gLineLen;		// 荞݂ɕKv\ȃXy[X
	if ((buf = (char*) malloc(size))!=NULL){					// Ɨ̈mۂłȂ
		pos = 0;
		while (rno!=rnoEnd || cxr!=cxrEnd){
			buf[pos++] = gText[rno]->text[cxr++];
			if (gText[rno]->len<=cxr){
				cxr = 0;
				rno = gText[rno]->chainNext;
				if (rno==0xFFFFFFFF) break;
			}
		}
		buf[pos] = '\0';
	}
	return (buf);
}

void TextCopy(void)
{
	if (gTextClip!=NULL) free(gTextClip);						// Ɏ荞܂Ă镶͂폜
	gTextClip = TextCapture();
}

//==============================================================
// j[i͈͍폜j
//--------------------------------------------------------------
// gTSel[0]`gTSel[1]͈̔͂̃eLXg폜܂B
// ͈͎w肪LȏԂŎs邱ƁB
// sAJ[\ʒu폜JnʒuɈړ܂B
// ʍ͍s܂B
//--------------------------------------------------------------

void TextDel(struct strCsrSts *cs)
{
	int		cxr,cxrEnd;
	long	rno,rnoEnd,pos0,pos1,lp,plineBak;

	pos0 = gTSel[0].line * gLineLen + gTSel[0].cxr;
	pos1 = gTSel[1].line * gLineLen + gTSel[1].cxr;
	if (pos0==pos1) return;
	if (pos0>pos1){												// ̊JnʒuƏIʒu
		rno = gTSel[1].rno;
		cxr = gTSel[1].cxr;
		rnoEnd = gTSel[0].rno;
		cxrEnd = gTSel[0].cxr;
	} else {
		rno = gTSel[0].rno;
		cxr = gTSel[0].cxr;
		rnoEnd = gTSel[1].rno;
		cxrEnd = gTSel[1].cxr;
	}

	gSave = 1;
	cs->cxr = cxrEnd;
	cs->rno = rnoEnd;
	plineBak = cs->pline;
	CRSet(cs);													// ͈͎w̍ŌʒuɃJ[\ʒuړ
	while ((cs->rno)!=rno || (cs->cxr)!=cxr){					// 1ÂĂ
		CMLeft( cs,0 );											// J[\obN
		DelStr( cs,0,1 );
	}

	lp = GetLine(rno);
	if (plineBak!=cs->pline){									// J[\ʒuʔ͈͂Oꂽ
		cs->cy = 0;
		cs->pline = lp;
	} else {
		cs->cy = lp - (cs->pline);
	}
}

//==============================================================
// j[it@Ce̓\tj
//--------------------------------------------------------------
// ꂪgƂȂ񂩕֗炵ƕ̂ŎĂ݂B
// Ώۃt@C͓̕sR[hCRLFLFɑΉB
//--------------------------------------------------------------

int FilePaste(struct strCsrSts *cs)
{
	char	c,*data,path[1024],msg[128];
	int		fd;
	long	i,pos1,pos2,filesize;

	//----- t@CI -----

	if (SelectFile("t@C\\t",gPFolder,"",path,0))
		return (-1);											// LZꂽ

	//----- t@Cǂݍ -----

	fd = sceIoOpen( path, PSP_O_RDONLY, 0777 );
	data = NULL;
	if (fd>=0){
		filesize = sceIoLseek( fd, 0, SEEK_END );
		sceIoLseek( fd, 0, SEEK_SET );
		data = (char*) malloc(filesize);
		if (data==NULL){										// mۂłȂ
			strcpy( msg,"[Nmۂł܂łB" );
		} else {
			sceIoRead( fd, data, filesize );
		}
		sceIoClose(fd);
	} else {
		strcpy( msg,"t@CJ܂łB" );
	}
	if (data==NULL){											// 蔭
		DiaBox1( -1, 120, 0, msg, gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
		Unpush();												// {^܂őҋ@
		WaitBtn();												// ܂őҋ@
		return (0);
	}

	//----- sR[hC -----

	pos1 = 0;
	pos2 = 0;
	for (i=0; i<filesize ;i++){
		c = data[pos1++];
		if (c!='\r' && c!=0x1A)									// CREOF菜
			data[pos2++] = c;
	}
	data[pos2] = '\0';

	//----- ͂ɓ\t -----

	if (strlen(data)){											// ͂Ȃ
		if (AddStr( cs, data, 0, 1)){
			DiaBox1( -1, 120, 0, "ȂȂ܂B", gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
			Unpush();												// {^܂őҋ@
			WaitBtn();												// ܂őҋ@
		}
		gSave = 1;
	}

	//----- n -----

	free(data);
	return (0);
}

//==============================================================
// j[it@C֐؂oj
//--------------------------------------------------------------
// gTSel[0]`gTSel[1]͈̔͂̃eLXgwt@C֏o܂B
// ͈͎w肪LȏԂŎs邱ƁB
//--------------------------------------------------------------

int TextSave(void)
{
	char	*buf,*buf2,path[1024];
	int		fd;
	long	i,pos,size;

	buf = TextCapture();										// w͈͂̃eLXg荞
	if (!buf) return (2);
	if (gCRLF){
		size = 0;
		for (i=0; i<strlen(buf) ;i++){
			size += (buf[i]=='\n' ? 2 : 1);
		}
		buf2 = (char*) malloc(size);
		if (buf2){
			pos = 0;
			for (i=0; i<strlen(buf) ;i++){
				if (buf[i]=='\n'){
					buf2[pos++] = '\r';
					buf2[pos++] = '\n';
				} else {
					buf2[pos++] = buf[i];
				}
			}
			free(buf);
			buf = buf2;
		}
	} else {
		size = strlen(buf);
	}

	if (SelectFile("t@C֐؂o",gPFolder,"",path,-1)){
		free(buf);
		return (2);												// LZꂽ
	}
	fd = sceIoOpen( path, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
	if (fd>=0){
		sceIoWrite( fd, buf, size );
		sceIoClose(fd);
	}
	free(buf);
	return (0);
}

//==============================================================
// j[iwsփWvj
//--------------------------------------------------------------
// ͂ꂽ_sʒuֈړB
//--------------------------------------------------------------

int TextJump(struct strCsrSts *cs)
{
	char	msg[128],str[10];
	long	rno,rline,pline,maxline;

	rno = 0;
	maxline = 0;
	do{															// s̑JEg
		if (gText[rno]->enter) maxline++;
		rno = gText[rno]->chainNext;
	} while (rno!=0xFFFFFFFF);

	sprintf( msg,"Wvsʒu͂ĂBi1`%ldj",maxline+1 );
	if (InputName(msg,9,"",str)){
		return (-1);											// LZ
	}
	if (strlen(str)==0) return (-1);
	rline = atol(str) -1;
	if (rline<0) rline = 0;
	if (rline>maxline) rline = maxline;

	rno = 0;
	pline = 0;
	maxline = 0;
	while (rline!=maxline && rno!=0xFFFFFFFF){					// w_sʒuT
		if (gText[rno]->enter) maxline++;
		pline++;
		rno = gText[rno]->chainNext;
	};
	SetCursor( cs,pline );										// wsʒuɕJ[\ړ

	cs->cx = 0;													// ʏł̕J[\XʒuiPʁj
	cs->sx = 0;													// ʏł̕J[\XʒuihbgPʁj
	cs->cxr = 0;												// _J[\Xʒu
	cs->cxb = 0;												// J[\Xʒuw莞̓BڕW|CgihbgPʁj
	cs->adjust = 1;												// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
	return (0);
}

//==============================================================
// j[i񌟍j
//--------------------------------------------------------------

//----- I𕶎̎荞 -----

int GetStrBlk(char *str)
{
	int		cxr,cxrEnd,pos;
	long	rno,rnoEnd,pos0,pos1;

	str[0] = '\0';
	if (gTSel[0].rno!=-1){
		pos0 = gTSel[0].line * gLineLen + gTSel[0].cxr;
		pos1 = gTSel[1].line * gLineLen + gTSel[1].cxr;
		if (pos0>pos1){											// ̊JnʒuƏIʒu
			rno = gTSel[1].rno;
			cxr = gTSel[1].cxr;
			rnoEnd = gTSel[0].rno;
			cxrEnd = gTSel[0].cxr;
		} else {
			rno = gTSel[0].rno;
			cxr = gTSel[0].cxr;
			rnoEnd = gTSel[1].rno;
			cxrEnd = gTSel[1].cxr;
		}

		pos = 0;
		while (rno!=rnoEnd || cxr!=cxrEnd){
			if (gText[rno]->text[cxr]<32U) break;				// Rg[R[h͑ΏۂɂȂȂ
			str[pos++] = gText[rno]->text[cxr++];
			if (pos>50) break;									// 
			if (gText[rno]->len<=cxr){
				cxr = 0;
				rno = gText[rno]->chainNext;
				if (rno==0xFFFFFFFF) break;
			}
		}
		str[pos] = '\0';
	}
	return (strlen(str));
}

//----- ݂̃J[\ʒuȍ~Ŏw肳ꂽ̂ʒuɃJ[\Zbg -----

int StrSrchSub(struct strCsrSts *cs,char *str)
{
	int		i,pos,pos1,posx;
	long	rno,rno2,pline;

	rno = cs->rno;
	pline = cs->pline + cs->cy;
	pos = cs->cxr;
	pos++;
	if (gText[rno]->len<pos){									// Jn̓J[\ʒu̎
		pos = 0;
		rno = gText[rno]->chainNext;
		pline++;
	}
	posx = -1;
	while (rno!=0xFFFFFFFF){
		for (pos=pos; pos<gText[rno]->len ;pos++){
			if (gText[rno]->text[pos]==str[0]){					// ꕶڂĂH
				pos1 = pos;
				rno2 = rno;
				for (i=1; i<strlen(str) ;i++){					// 񕶎ڈȍ~
					pos1++;
					if (gText[rno2]->len<pos1){					// s[𒴂鏈
						if (gText[rno2]->enter) break;			// sȂ`FbN~
						pos1 = 0;
						rno2 = gText[rno2]->chainNext;
						if (rno2==0xFFFFFFFF) break;			// [EOF]ɂԂ
					}
					if (gText[rno2]->text[pos1]!=str[i]) break;	// 񕶎ڈȍ~ňvȂȂ
				}
				if (strlen(str)==i){							// ڕWI
					posx = pos;
					break;
				}
			}
		}
		if (posx!=-1) break;									// ڕWI
		pos = 0;
		rno = gText[rno]->chainNext;
		pline++;
	}

	//----- ڕWʒuɃJ[\ړ -----

	if (posx==-1){												// ڕWȂ炸
		return (-1);
	}
	SetCursor( cs,pline );										// wsʒuɕJ[\ړ
	cs->cxr = posx;
	CRSet(cs);													// w肳ꂽ_ʒuɃJ[\ړ
	ScreenAdj(cs);
	cs->adjust = 0;												// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
	DrawSts( cs, 1 );											// [[nƃXN[o[XV
	DrawFullRec(cs->pline);										// ʑS
	return (0);
}

//----- _CAO -----

void DrawStrSrch(int no)
{
	int		x,y;

	x = 480-4-130;
	y = 272-4-56;
	CurveBox( x, y, 10+110+10, 6+12+4+13*1-1+4+12+6, 4, gSCor[1], gSCor[2] );	// _CAOO`
	mh_print( x+10, y+6, "񌟍", gSCor[1] );
	mh_print( x+10+12, y+6+12+4+13*1-1+4, ":I ~:ݾ", gSCor[1] );
	Fill( x+10, y+6+12+4, 110, 12, gSCor[5] );
	CurveBox( x+10, y+6+12+4, 110, 12, 0, gSCor[10], gSCor[11] );
	mh_print( x+10+1, y+6+12+4, "̌", gSCor[0] );
}

//----- C -----

int StrSrch(struct strCsrSts *cs)
{
	SceCtrlData		pad;
	static char	strBuf[51];
	char	str[51];
	int		x,y,no,ret,exit;
	DrawImg	*image;

	//----- I𕶎̎荞 -----

	if (GetStrBlk(str)!=0) strcpy( strBuf,str );				// 񂪎擾oĂȂ̗p

	//-----  -----

	if (InputName("镶͂ĂB",50,strBuf,str)){
		return (-1);											// LZ
	}
	if (strlen(str)==0) return (-1);
	strcpy( strBuf,str );
	gTSel[0].rno = -1;											// I𕶎̉

	//----- 񌟍 -----

	if (StrSrchSub( cs,str )){									// ̌₪ȂI
		return (1);
	}
	image = ScreenCopy();
	exit = 0;
	no = 0;
	DrawStrSrch(no);
	while (!gExitRequest && !exit){								// L[̓[v
		x = cs->sx - gXOffset;
		y = TBY + cs->cy * gFHeight;							// J[\Wݒ
		SIMEcursor( 2, &x, &y );								// J[\̑傫ƍWϐ̎w
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		DrawCursor(ret);										// SIMEJ[\̍
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			ScreenPaste(image);
			if (StrSrchSub( cs,str )){							// ̌₪ȂI
				exit = -1;
			} else {
				image = ScreenCopy();
				DrawStrSrch(no);
			}
			break;
		case SIME_KEY_CROSS:									// ~
			ScreenPaste(image);
			exit = -1;
			break;
		case SIME_KEY_UP:										// 
			no = 0;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawStrSrch(no);
			break;
		case SIME_KEY_DOWN:										// 
			no = 1;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawStrSrch(no);
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}

	return (0);
}

//==============================================================
// j[iuj
//--------------------------------------------------------------

//----- _CAOiݒʁj -----

void DrawStrChgSet(int no,char *str1,char *str2)
{
	if (!no){
		CurveBox( 240-346/2+10+6*4+2  , 90+6+12+4, 300, 12, 0, gSCor[10], gSCor[11] );
		mh_print( 240-346/2+10+6*4+2+1, 90+6+12+4, str1, gSCor[0] );
		Fill(     240-346/2+10+6*4+2  , 90+6+12+4+13, 300, 12, gSCor[5] );
		mh_print( 240-346/2+10+6*4+2+1, 90+6+12+4+13, str2, gSCor[0] );
	} else {
		Fill(     240-346/2+10+6*4+2  , 90+6+12+4, 300, 12, gSCor[5] );
		mh_print( 240-346/2+10+6*4+2+1, 90+6+12+4, str1, gSCor[0] );
		CurveBox( 240-346/2+10+6*4+2  , 90+6+12+4+13, 300, 12, 0, gSCor[10], gSCor[11] );
		mh_print( 240-346/2+10+6*4+2+1, 90+6+12+4+13, str2, gSCor[0] );
	}
}

//----- _CAOiumFj -----

void DrawStrChgNext(int no)
{
	int		x,y;

	x = 480-4-130;
	y = 272-4-69;
	CurveBox( x, y, 10+110+10, 6+12+4+13*2-1+4+12+6, 4, gSCor[1], gSCor[2] );	// _CAOO`
	mh_print( x+10, y+6, "u", gSCor[1] );
	mh_print( x+10+12, y+6+12+4+13*2-1+4, ":I ~:ݾ", gSCor[1] );
	if (no){
		Fill( x+10, y+6+12+4, 110, 12, gSCor[5] );
		CurveBox( x+10, y+6+12+4+13, 110, 12, 0, gSCor[10], gSCor[11] );
	} else {
		CurveBox( x+10, y+6+12+4, 110, 12, 0, gSCor[10], gSCor[11] );
		Fill( x+10, y+6+12+4+13, 110, 12, gSCor[5] );
	}
	mh_print( x+10+1, y+6+12+4   , "uĎ̌", gSCor[0] );
	mh_print( x+10+1, y+6+12+4+13, "̂܂܎̌", gSCor[0] );
}

//----- C -----

int StrChg(struct strCsrSts *cs)
{
	SceCtrlData		pad;
	static char	source[51] = {0},								// ƂȂ镶
				dest[51] = {0};									// u镶
	char	str[51];											// ꎞp
	int		x,y,no,pos,ret,exit;
	DrawImg	*image;

	//----- I𕶎̎荞 -----

	if (GetStrBlk(str)!=0){
		strcpy( source,str );									// 񂪎擾oĂȂ̗p
	}

	//----- ݒ -----

	CurveBox( 240-346/2, 90, 346, 6+12+4+13*2-1+4+12+6, 4, gSCor[1], gSCor[2] );	// _CAOO`
	mh_print( 240-346/2+10, 90+6, "u", gSCor[1] );
	mh_print( 240-346/2+10, 90+6+12+4   , "", gSCor[0] );
	mh_print( 240-346/2+10, 90+6+12+4+13, "u", gSCor[0] );
	mh_print( 240+346/2-10-32*6, 90+6+12+4+13*2-1+4, ":ݒύX : ~:ݾ", gSCor[1] );
	no = 0;
	DrawStrChgSet( no,source,dest );

	exit = 0;
	while (!gExitRequest && !exit){								// L[̓[v
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			exit = 1;
			break;
		case SIME_KEY_CROSS:									// ~
			exit = -1;
			break;
		case SIME_KEY_TRIANGLE:									// 
		case SIME_KEY_LEFT:										// 
		case SIME_KEY_RIGHT:									// 
			image = ScreenCopy();
			if (no==0){
				if (!InputName("u錳͂̕ĂB",50,source,str)){
					strcpy( source,str );
				}
			} else {
				if (!InputName("u͂̕ĂB",50,dest,str)){
					strcpy( dest,str );
				}
			}
			ScreenPaste(image);
			DrawStrChgSet( no,source,dest );
			break;
		case SIME_KEY_UP:										// 
			no = 0;
			DrawStrChgSet( no,source,dest );
			break;
		case SIME_KEY_DOWN:										// 
			no = 1;
			DrawStrChgSet( no,source,dest );
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();
	}

	if (gExitRequest || exit==-1 || strlen(source)==0){			// LZꂽ
		return (-1);
	}
	gTSel[0].rno = -1;											// I𕶎̉

	//----- 񌟍ƒu -----

	if (StrSrchSub( cs,source )){								// ̌₪ȂI
		return (1);
	}
	image = ScreenCopy();
	exit = 0;
	no = 0;
	DrawStrChgNext(no);
	while (!gExitRequest && !exit){								// L[̓[v
		x = cs->sx - gXOffset;
		y = TBY + cs->cy * gFHeight;							// J[\Wݒ
		SIMEcursor( 2, &x, &y );								// J[\̑傫ƍWϐ̎w
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		DrawCursor(ret);										// SIMEJ[\̍
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			ScreenPaste(image);
			if (no==0){											// ̒us
				pos = 0;
				while (strlen(source)>pos){						// ̌܂ňړ
					CMRight( cs, 0 );
					if (chkSJIS(source[pos++])) pos++;
				}
				pos = 0;
				while (strlen(source)>pos){						// 폜
					CMLeft( cs, 0 );
					DelStr( cs, 0, 1 );
					if (chkSJIS(source[pos++])) pos++;
				}
				AddStr( cs, dest, 0, 1 );						// u
				gSave = 1;
			}
			if (StrSrchSub( cs,source )){						// ̌₪ȂI
				DrawRec( cs->cy, cs->rno );						// Ō̒uɔf
				exit = -1;
			} else {
				image = ScreenCopy();
				DrawStrChgNext(no);
			}
			break;
		case SIME_KEY_CROSS:									// ~
			ScreenPaste(image);
			exit = -1;
			break;
		case SIME_KEY_UP:										// 
			no = 0;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawStrChgNext(no);
			break;
		case SIME_KEY_DOWN:										// 
			no = 1;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawStrChgNext(no);
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}

	return (0);
}

//==============================================================
// j[iݒj
//--------------------------------------------------------------

//----- J[\ݒe -----

void SetEnvCsr(int pos,int *itemdata,int flag)
{
	const char	sel[7][5][13] = {
					{"_tHg",	"monafont12",	"monafont16",	"intraFont",	"intraFont P"},
					{"Ȃ",			""},
					{"Simple IME",		"OSK"},
					{"S",				"W"},
					{"Ȃ",			""},
					{"Ȃ",			""},
					{"Ȃ",			""},
				};
	static int	pos2;
	int			i,p;

	if (flag){													// Ŝ
		for (i=0; i<6 ;i++){
			Fill( 100+10+22*6, 53+6+12+6+i*13, 76, 12, gSCor[5] );
			mh_print( 100+10+22*6+2, 53+6+12+6+i*13, sel[i][itemdata[i]], gSCor[0] );
		}
		for (i=0; i<4 ;i++){
			Fill( 100+10+22*6, 53+6+12+6+6*13+i*13, 136, 12, gSCor[5] );
			p = strlen(gMonaFile[i]) -22;						// 납22\
			if (p<0) p = 0;
			mh_print( 100+10+22*6+2, 53+6+12+6+6*13+i*13, &gMonaFile[i][p], gSCor[0] );
		}
	} else {													// ÕJ[\ʒuĕ`
		if (pos2<6){
			Fill( 100+10+22*6, 53+6+12+6+pos2*13, 76, 12, gSCor[5] );
			mh_print( 100+10+22*6+2, 53+6+12+6+pos2*13, sel[pos2][itemdata[pos2]], gSCor[0] );
		} else {
			Fill( 100+10+22*6, 53+6+12+6+pos2*13, 136, 12, gSCor[5] );
			p = strlen(gMonaFile[pos2-6]) -22;					// 납22\
			if (p<0) p = 0;
			mh_print( 100+10+22*6+2, 53+6+12+6+pos2*13, &gMonaFile[pos2-6][p], gSCor[0] );
		}
	}

	if (pos<6){
		CurveBox( 100+10+22*6, 53+6+12+6+pos*13, 76, 12, 0, gSCor[10], gSCor[11] );
		mh_print( 100+10+22*6+2, 53+6+12+6+pos*13, sel[pos][itemdata[pos]], gSCor[0] );
	} else {
		CurveBox( 100+10+22*6, 53+6+12+6+pos*13, 136, 12, 0, gSCor[10], gSCor[11] );
		p = strlen(gMonaFile[pos-6]) -22;						// 납22\
		if (p<0) p = 0;
		mh_print( 100+10+22*6+2, 53+6+12+6+pos*13, &gMonaFile[pos-6][p], gSCor[0] );
	}

	pos2 = pos;
}

//----- tHgt@C̎wύX -----

int SetEnvFont(int font)
{
	const char	itemname[][21] = {
					"12hbgpmonafont",
					"12hbgSpmonafont",
					"16hbgpmonafont",
					"16hbgSpmonafont",
				};
	char	*p,msg[64],path[1024],filename[128];
	int		fd,ret;
	DrawImg	*image;

	image = ScreenCopy();										// ʃC[WҔ
	strcpy( msg,itemname[font] );
	strcat( msg,"̃t@Cw" );
	ret = 0;
	strcpy( path,gMonaFile[font] );
	p = strrchr( path,'/' );
	strcpy( filename,&p[1] );
	p[1] = '\0';
	if (!SelectFile(msg,path,filename,path,0)){
		fd = sceIoOpen( path, PSP_O_RDONLY, 0777 );
		sceIoClose(fd);
		if (fd>=0){
			strcpy( gMonaFile[font],path );
			ret = 1;
		} else {												// w肳ꂽt@CJȂ
			DiaBox1( -1, 120, 0, "w肳ꂽtHgɃANZXł܂B", gSCor[0], gSCor[3], gSCor[4] );
			Unpush();											// {^܂őҋ@
			WaitBtn();											// ܂őҋ@
		}
	}
	ScreenPaste(image);											// ʃC[W𕜌/obt@j
	return (ret);
}

//----- C -----

int SetEnv(struct strCsrSts *cs)
{
	const char	itemname[][21] = {
					"tHg",
					"ʉTCYg",
					"IME̎",
					"^u",
					"Sp󔒂L\\",
					"^uL\\",
					"12hbgpmonafont",
					"12hbgSpmonafont",
					"16hbgpmonafont",
					"16hbgSpmonafont",
				};
	SceCtrlData	pad;
	char		msg[128];
	int			i,pos,ret,tabBak,fontBak,rollBak,saveBak,rollChg,fontChg,itemdata[6];
	long		no,rno,line,pline;
	DrawImg		*image;

	CurveBox( 100, 53, 286, 178, 4, gSCor[1], gSCor[2] );
	strcpy( msg,VERSION );
	strcat( msg,"   By.STEAR 2009" );
	mh_print( 100+10, 53+6, msg, gSCor[1] );
	for (i=0; i<10 ;i++){
		mh_print( 100+10, 53+6+12+6+i*13, itemname[i], gSCor[0] );
	}
	mh_print( 100+286-10-30*6, 53+178-6-12, ":ݒύX : ~:ݾ", gSCor[1] );

	itemdata[0] = gFont;
	itemdata[1] = gRoll;
	itemdata[2] = gIME;
	itemdata[3] = gTab;
	itemdata[4] = gPSpc;
	itemdata[5] = gPTab;
	tabBak = gTab;												// ^uς`FbN邽
	fontBak = gFont;											// tHgς`FbN邽
	rollBak = gRoll;
	fontChg = 0;												// tHgt@CύXH
	pos = 0;
	SetEnvCsr( pos, itemdata, 1);

	while (!gExitRequest){										// L[̓[v
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			gFont = pf_fontType(itemdata[0]);					// tHg؂ւ
			setScreen();										// p[^ύX
			if (cs->cy>=gSLine) cs->cy = gSLine - (gReDraw ? 2 : 1);
			SIMEfont(gFont,(gFont==2 ? 16 : 12));				// SIMEϊstHg
			rollChg = 0;
			if (gRoll!=itemdata[1]){
				gRoll = itemdata[1];
				gXOffset = 0;
				rollChg = 1;
			}
			gIME = itemdata[2];
			gTab = itemdata[3];
			gPSpc = itemdata[4];
			gPTab = itemdata[5];
			if (fontChg){										// tHgt@CύX
				ret = 0;
				msg[0] = '\0';
				if ( (ret=pf_setMonaFont(0,gMonaFile[0],gMonaFile[1])) ){
					strcat( msg,"12hbgmonafont" );
				}
				if (pf_setMonaFont(1,gMonaFile[2],gMonaFile[3])){
					if (ret){
						strcat( msg,"" );
					}
					strcat( msg,"16hbgmonafont" );
				}
				if (strlen(msg)){
					strcat( msg,"̃[hɎs܂B" );
					DiaBox1( -1, 110, 0, msg, gSCor[0], gSCor[3], gSCor[4] );
					Unpush();									// {^܂őҋ@
					WaitBtn();									// ܂őҋ@
				}
			}
			if (tabBak!=gTab || fontBak!=gFont || fontChg || rollChg){	// sR[h\ɕωꍇ
				DiaBox1( -1, 100, 0, "͂č\\Ă܂B\nX҂B", gSCor[0], gSCor[1], gSCor[2] );
				ScreenView();									// ʍXV
				pline = 0;
				rno = 0;
				line = 0;
				while (pline<(cs->pline)+(cs->cy)){				// ʏ\Jn_s擾
					if (gText[rno]->enter) line++;
					pline++;
					rno = gText[rno]->chainNext;
					if (rno==0xFFFFFFFF) break;
				}
				saveBak = gSave;
				msg[0] = '\0';
				image = ScreenCopy();
				ret = filesave("SMEMO_TEMP.TEMP");				// ꎞƗpt@Cɕۑ
				ScreenPaste(image);
				if (ret==0){
					ret = fileload("SMEMO_TEMP.TEMP");			// ă[hi̎_ŕ͂̍č\sj
					if (ret==0){								// IȂ
						sceIoRemove("SMEMO_TEMP.TEMP");			// ꎞt@C폜
					}
					switch (ret){
					case 2:
						strcpy( msg,"rŃLZ܂B\n͂̌㔼Ă܂B" );
						break;
					case 1:
						strcpy( msg,"ŝߏf܂B\n͂̌㔼Ă܂B" );
						break;
					case -1:
						strcpy( msg,"ŝߏɎs܂B" );
						break;
					case -2:
						strcpy( msg,"[XeBbÑANZXŃG[߁AɎs܂B" );
						break;
					}
					if (ret){
						strcat( msg,"\nO͂̕ SMEMO_TEMP.TEMP ɎcĂ邩܂B" );
					}
				} else {										// ƃt@Cւ̕ۑɎŝŐݒɖ߂
					gTab = tabBak;
					gFont = fontBak;
					gRoll = rollBak;
					setScreen();								// p[^ύX
					switch (ret){
					case -1:
						strcpy( msg,"ŝߏLZ܂B" );
						break;
					case -2:
						strcpy( msg,"[XeBbÑANZXŃG[߁ALZ܂B" );
						break;
					}
					strcat( msg,"\neݒɖ߂܂B" );
				}
				gSave = saveBak;
				if (strlen(msg)){								// 蔭
					DiaBox1( -1, 130, 0, msg, gSCor[0], gSCor[3], gSCor[4] );
					Unpush();									// {^܂őҋ@
					WaitBtn();									// ܂őҋ@
				}
				if (ret>=0){									// G[ĂȂꍇ
					no = 0;
					pline = 0;
					rno = 0;
					while (no!=line){
						if (gText[rno]->enter) no++;
						pline++;
						rno = gText[rno]->chainNext;
						if (rno==0xFFFFFFFF) break;
					}
					SetCursor( cs,pline );						// wsʒuɕJ[\ړ
					CMSet( &cs->cx, &cs->sx, &cs->cxr, (cs->cxb)+1, cs->rno, 1 );	// J[\ʒusR[h{ɍ悤ɕ␳
				}
			}
			return (0);
			break;
		case SIME_KEY_CROSS:									// ~
			return (-1);
			break;
		case SIME_KEY_LEFT:										// 
			if (pos<6){
				if (itemdata[pos]>0){
					itemdata[pos]--;
					SetEnvCsr( pos, itemdata, 0);
				}
			} else {
				if (SetEnvFont(pos-6)){							// tHgw
					fontChg = 1;
					SetEnvCsr( pos, itemdata, 0);
				}
			}
			break;
		case SIME_KEY_RIGHT:									// 
			if (pos<6){
				if ((pos==0 && itemdata[pos]<4) || itemdata[pos]<1){
					itemdata[pos]++;
					SetEnvCsr( pos, itemdata, 0);
				}
			} else {
				if (SetEnvFont(pos-6)){							// tHgw
					fontChg = 1;
					SetEnvCsr( pos, itemdata, 0);
				}
			}
			break;
		case SIME_KEY_UP:										// 
			if (pos>0){
				pos--;
				SetEnvCsr( pos, itemdata, 0);
			}
			break;
		case SIME_KEY_DOWN:										// 
			if (pos<9){
				pos++;
				SetEnvCsr( pos, itemdata, 0);
			}
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();
	}
	return (-1);
}

//==============================================================
// j[i蒼j
//--------------------------------------------------------------

//----- _CAO -----

void DrawUndo(int no,int flag1,int flag2)
{
	int		x,y;

	x = 480-4-130;
	y = 272-4-69;
	CurveBox( x, y, 10+110+10, 6+12+4+13*2-1+4+12+6, 4, gSCor[1], gSCor[2] );	// _CAOO`
	mh_print( x+10, y+6, "蒼", gSCor[1] );
	mh_print( x+10+12, y+6+12+4+13*2-1+4, ":I ~:ݾ", gSCor[1] );
	if (no){
		Fill( x+10, y+6+12+4, 110, 12, gSCor[5] );
		CurveBox( x+10, y+6+12+4+13, 110, 12, 0, gSCor[10], gSCor[11] );
	} else {
		CurveBox( x+10, y+6+12+4, 110, 12, 0, gSCor[10], gSCor[11] );
		Fill( x+10, y+6+12+4+13, 110, 12, gSCor[5] );
	}
	mh_print( x+10+1, y+6+12+4   , "蒼", (flag1 ? gSCor[0] : gSCor[12]) );
	mh_print( x+10+1, y+6+12+4+13, "蒼̂蒼", (flag2 ? gSCor[0] : gSCor[12]) );
}

//----- 蒼 -----

void UndoUndo(struct strCsrSts *cs,int *size,int *pos)
{
	if (*size==0) return;
	(*pos)--;
	if (*pos<0) *pos = UNDOSIZE -1;
	(*size)--;

	SetCursor( cs,gUndo[*pos].pline );							// wsʒuɕJ[\ړ
	cs->cxr = gUndo[*pos].cxr;
	CRSet(cs);													// w肳ꂽ_ʒuɃJ[\ړ
	if (gUndo[*pos].str[2]==1){									// ͂Ăꍇ
		DelStr( cs, 0, 0 );
	} else {													// 폜Ăꍇ
		AddStr( cs, gUndo[*pos].str, 0, 0 );
	}
	ScreenAdj(cs);
	cs->adjust = 0;												// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
	DrawSts( cs, 1 );											// [[nƃXN[o[XV
	DrawFullRec(cs->pline);										// ʑS
}

//----- 蒼̂蒼 -----

void UndoRedo(struct strCsrSts *cs,int *size,int *pos)
{
	char	str[3] = {0,0,0};

	if (*size==gUndoSize) return;

	SetCursor( cs,gUndo[*pos].pline );							// wsʒuɕJ[\ړ
	cs->cxr = gUndo[*pos].cxr;
	CRSet(cs);													// w肳ꂽ_ʒuɃJ[\ړ
	if (gUndo[*pos].str[2]==1){									// ͂Ăꍇ
		str[0] = gUndo[*pos].str[0];
		str[1] = gUndo[*pos].str[1];
		AddStr( cs, str, 0, 0 );
	} else {													// 폜Ăꍇ
		DelStr( cs, 0, 0 );
	}
	ScreenAdj(cs);
	cs->adjust = 0;												// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
	DrawSts( cs, 1 );											// [[nƃXN[o[XV
	DrawFullRec(cs->pline);										// ʑS

	(*pos)++;
	if (*pos>=UNDOSIZE) *pos = 0;
	(*size)++;
}

//----- C -----

int Undo(struct strCsrSts *cs)
{
	SceCtrlData		pad;
	int		x,y,no,ret,exit,size,pos;
	DrawImg	*image;

	if (gUndoSize==0) return(-1);								// ss
	size = gUndoSize;
	pos = gUndoPos;
	UndoUndo( cs,&size,&pos );
	no = 0;
	image = ScreenCopy();
	DrawUndo( no, (size!=0), (size!=gUndoSize) );

	exit = 0;
	while (!gExitRequest && !exit){								// L[̓[v
		x = cs->sx - gXOffset;
		y = TBY + cs->cy * gFHeight;							// J[\Wݒ
		SIMEcursor( 2, &x, &y );								// J[\̑傫ƍWϐ̎w
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		DrawCursor(ret);										// SIMEJ[\̍
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			if (no==0){
				if (size!=0){
					DrawImgFree(image);
					UndoUndo( cs,&size,&pos );
					gSave = 1;
					image = ScreenCopy();
					DrawUndo( no, (size!=0), (size!=gUndoSize) );
				}
			} else {
				if (size!=gUndoSize){
					DrawImgFree(image);
					UndoRedo( cs,&size,&pos );
					gSave = 1;
					image = ScreenCopy();
					DrawUndo( no, (size!=0), (size!=gUndoSize) );
				}
			}
			break;
		case SIME_KEY_CROSS:									// ~
			ScreenPaste(image);
			gUndoPos = pos;
			gUndoSize = size;
			exit = -1;
			break;
		case SIME_KEY_UP:										// 
			no = 0;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawUndo( no, (size!=0), (size!=gUndoSize) );
			break;
		case SIME_KEY_DOWN:										// 
			no = 1;
			ScreenPaste(image);
			image = ScreenCopy();
			DrawUndo( no, (size!=0), (size!=gUndoSize) );
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}
	return (0);
}

//==============================================================
// j[iڂ̑Ij
//--------------------------------------------------------------
// ߂l  3:j[Iiʂ͍̕sȂj
//         2:j[IʍXV
//         1:j[Iʏ
//         0:j[Iiʂ͂̂܂܁j
//        -1:j[IAvI
//        -2:LZiĂуj[ցj
//--------------------------------------------------------------
// j[̍ڂIɎs̓IȓeB
//--------------------------------------------------------------

int MenuSelect(char *filepath,int tab,int pos,struct strCsrSts *cs)
{
	char	*p,path[1024];
	int		ret;

	//----- ut@Cv -----

	switch (tab){
	case 0:
		switch (pos){
		case 0:													// VK쐬
			if (gSave){											// XVĂꍇ͔jmF
				if (!MenuDLGyn( "ҏW͔͂̕j܂B", gSCor[3], gSCor[4] ))
					return (-2);
			}
			InitRec();
			p = strrchr( filepath,'/' );
			strcpy( &p[1],"NEW.TXT" );
			gTSel[0].rno = -1;									// ͈͎w
			return (1);
			break;
		case 1:													// J
			if (gSave){											// XVĂꍇ͔jmF
				if (!MenuDLGyn( "ҏW͔͂̕j܂B", gSCor[3], gSCor[4] ))
					return (-2);
			}
			p = strrchr( filepath,'/' );
			if (!SelectFile("ҏW镶͂Ił",gFolder,&p[1],filepath,0)){
				gTSel[0].rno = -1;								// ͈͎w
				DiaBox1( -1, 100, 0, "t@Cǂݍł܂B\nX҂B", gSCor[0], gSCor[1], gSCor[2] );
				MenuLoad(filepath);
				return (1);
			}
			return (-2);										// uJvLZ
			break;
		case 2:													// ㏑ۑ
			if (MenuDLGyn( "eLXgۑ܂H", gSCor[1], gSCor[2] )){
				MenuSave(filepath);
				return (0);
			}
			return (-2);										// LZ
			break;
		case 3:													// Otĕۑ
			strcpy( path,filepath );
			p = strrchr( path,'/' );
			if (!SelectFile("Otĕۑ",gFolder,&p[1],path,-1)){
				if (!MenuSave(path)){							// ۑꍇ̓t@CpX֘AXV
					strcpy( filepath,path );
				}
				return (1);										// ҏWΏۂύXɂȂ̂ŉʏ
			}
			return (-2);
			break;
		case 4:													// ۑďI
			if (MenuSave(filepath)){
				return (-2);									// G[/LZƏIȂ
			} else {
				gExitRequest = -1;
				return (-1);									// ۑ̂ŏI
			}
			break;
		case 5:													// I
			if (gSave){											// XVĂꍇ͔jmF
				if (!MenuDLGyn( "ҏW͔͂̕j܂B", gSCor[3], gSCor[4] ))
					return (-2);
			}
			gExitRequest = -1;
			return (-1);
			break;
		case 6:													// ݒ
			if (SetEnv(cs)){
				return (-2);									// LZ
			} else {
				return (2);
			}
			break;
		}
		break;

	//----- uҏWv -----

	case 1:
		switch (pos){
		case 0:													// 蒼
			gTSel[0].rno = -1;									// ͈͑Ỉ
			if (!Undo(cs)){
				return (3);
			}
			break;
		case 1:													// \t
			if (gTSel[0].rno!=-1){
				TextDel(cs);
				gTSel[0].rno = -1;								// ͈͑Ỉ
			}
			if (gTextClip==NULL) return (-2);
			TextPaste(cs);
			cs->adjust = 1;										// ʈʒuJ[\ʒu֍킹
			return (2);
			break;
		case 2:													// Rs[
			if (gTSel[0].rno==-1) return (-2);
			TextCopy();
			gTSel[0].rno = -1;									// ͈͑Ỉ
			return (2);
			break;
		case 3:													// ؂
			if (gTSel[0].rno==-1) return (-2);
			TextCopy();
			TextDel(cs);
			gTSel[0].rno = -1;									// ͈͑Ỉ
			cs->adjust = 1;										// ʈʒuJ[\ʒu֍킹
			return (2);
			break;
		case 4:													// 폜
			if (gTSel[0].rno==-1) return (-2);
			TextDel(cs);
			gTSel[0].rno = -1;									// ͈͑Ỉ
			cs->adjust = 1;										// ʈʒuJ[\ʒu֍킹
			return (2);
			break;
		case 5:													// t@C\t
			if (gTSel[0].rno!=-1){
				TextDel(cs);
				cs->adjust = 1;									// ʈʒuJ[\ʒu֍킹
				gTSel[0].rno = -1;
			}
			if (FilePaste(cs)){
				return (-2);									// LZ
			} else {
				cs->adjust = 1;									// ʈʒuJ[\ʒu֍킹
				return (2);
			}
			break;
		case 6:													// t@C֐؂o
			if (gTSel[0].rno==-1) return (-2);
			if (TextSave()){
				return (2);										// LZ
			} else {
				gTSel[0].rno = -1;
				return (2);
			}
			break;
		}
		break;

	//-----  -----

	case 2:
		switch (pos){
		case 0:													// 񌟍
			ret = StrSrch(cs);
			if (ret<0){
				return (-2);
			} else if (ret==0){
				gTSel[1].rno = cs->rno;							// eLXg͈͎wp
				gTSel[1].cxr = cs->cxr;
				gTSel[1].line = cs->pline + cs->cy -1;
				return (3);
			} else {
				return (2);
			}
			break;
		case 1:													// u
			ret = StrChg(cs);
			if (ret<0){
				return (-2);
			} else if (ret==0){
				gTSel[1].rno = cs->rno;							// eLXg͈͎wp
				gTSel[1].cxr = cs->cxr;
				gTSel[1].line = cs->pline + cs->cy -1;
				return (3);
			} else {
				return (2);
			}
			break;
		case 2:													// wsփWv
			if (TextJump(cs)){
				return (-2);
			} else {
				gTSel[1].rno = cs->rno;							// eLXg͈͎wp
				gTSel[1].cxr = cs->cxr;
				gTSel[1].line = cs->pline + cs->cy -1;
				return (2);
			}
			break;
		case 3:													// t@C̐擪
			SetCursor( cs,0 );									// wsʒuɕJ[\ړ
			cs->cx = 0;											// ʏł̕J[\XʒuiPʁj
			cs->sx = 0;											// ʏł̕J[\XʒuihbgPʁj
			cs->cxr = 0;										// _J[\Xʒu
			cs->cxb = 0;										// J[\Xʒuw莞̓BڕW|CgihbgPʁj
			cs->adjust = 1;										// ʈʒuJ[\ɍ킹i0:̂܂ 1:킹j
			gTSel[1].rno = cs->rno;								// eLXg͈͎wp
			gTSel[1].cxr = cs->cxr;
			gTSel[1].line = cs->pline + cs->cy -1;
			return (2);
			break;
		case 4:													// t@C̍Ō
			SetCursor( cs,gLineMax );							// wsʒuɕJ[\ړ
			cs->cxr = gText[cs->rno]->len;
			CRSet(cs);											// w肳ꂽ_ʒuɃJ[\ړ
			gTSel[1].rno = cs->rno;								// eLXg͈͎wp
			gTSel[1].cxr = cs->cxr;
			gTSel[1].line = cs->pline + cs->cy -1;
			return (2);
			break;
		case 5:													// ŌɕҏW
			if (gUndoSize!=0){
				pos = gUndoPos -1;
				if (pos<0) pos = UNDOSIZE -1;
				SetCursor( cs,gUndo[pos].pline );				// wsʒuɕJ[\ړ
				cs->cxr = gUndo[pos].cxr;
				CRSet(cs);										// w肳ꂽ_ʒuɃJ[\ړ
				gTSel[1].rno = cs->rno;							// eLXg͈͎wp
				gTSel[1].cxr = cs->cxr;
				gTSel[1].line = cs->pline + cs->cy -1;
				return (2);
			}
			break;
		case 6:
			break;
		}
		break;
	}
	return (-2);
}

//==============================================================
// j[
//--------------------------------------------------------------
// j[̍ƃL[͏B
//--------------------------------------------------------------

//----- ڍ -----

void DrawMenuSub(int tab,int pos,int sel)
{
	const char	item[3][7][17] = {{
					"VK쐬",
					"J",
					"㏑ۑ",
					"Otĕۑ",
					"ۑďI",
					"I",
					"ݒ",
				},{
					"蒼",
					"\\t",
					"Rs[",
					"؂",
					"폜",
					"̧ق\\t",
					"̧ق֐؂o",
				},{
					"񌟍",
					"u",
					"wsփWv",
					"t@C̐擪",
					"t@C̍Ō",
					"ŌɕҏW",
					"",
				}};
	long		cor;

	cor = gSCor[0];
	if (tab==1){												// O[AEg
		if (!(sel & 0x01) && pos==1) cor = gSCor[12];
		if (!(sel & 0x02) && ((pos>1 && pos<5) || pos == 6)) cor = gSCor[12];
		if (!(sel & 0x04) && pos==0) cor = gSCor[12];
	} else if (tab==2){
		if (!(sel & 0x04) && pos==5) cor = gSCor[12];
	}
	mh_print( 240-316/2+10+1+tab*100, 70+4+12+4+12+4+pos*13, item[tab][pos], cor );
}

//----- ^u -----

void DrawMenuTab(int tab)
{
	Fill( 240-316/2+10,     70+4+12+4, 52, 12, gSCor[5] );
	Fill( 240-316/2+10+100, 70+4+12+4, 28, 12, gSCor[5] );
	Fill( 240-316/2+10+200, 70+4+12+4, 28, 12, gSCor[5] );
	switch (tab){
	case 0:
		CurveBox( 240-316/2+10,    70+4+12+4, 52, 12, 0, gSCor[10], gSCor[11] );
		break;
	case 1:
		CurveBox( 240-316/2+10+100, 70+4+12+4, 28, 12, 0, gSCor[10], gSCor[11] );
		break;
	case 2:
		CurveBox( 240-316/2+10+200, 70+4+12+4, 28, 12, 0, gSCor[10], gSCor[11] );
		break;
	}
	mh_print( 240-316/2+10+1+1,     70+4+12+4, "t@C", gSCor[1] );
	mh_print( 240-316/2+10+1+100+1, 70+4+12+4, "ҏW", gSCor[1] );
	mh_print( 240-316/2+10+1+200+1, 70+4+12+4, "", gSCor[1] );
}

//----- J[\ -----

void DrawMenu(int tab,int pos,int flag,int sel)
{
	static int	pos2,tab2;
	int			i,j;

	if (flag){													// j[ڂ\đÕJ[\
		for (j=0; j<3 ;j++){
			for (i=0; i<7 ;i++){
				Fill( 240-316/2+10+j*100, 70+4+12+4+12+4+i*13, 98, 12, gSCor[5] );
				DrawMenuSub(j,i,sel);
			}
		}
	} else if (pos!=pos2 || tab!=tab2){
		Fill( 240-316/2+10+tab2*100, 70+4+12+4+12+4+pos2*13, 98, 12, gSCor[5] );
		DrawMenuSub(tab2,pos2,sel);
	}

	CurveBox( 240-316/2+10+tab*100, 70+4+12+4+12+4+pos*13, 98, 12, 0, gSCor[10], gSCor[11] );
	DrawMenuSub(tab,pos,sel);

	pos2 = pos;
	tab2 = tab;
}

//----- C -----

int menu(char *filepath,int tab,int sel,struct strCsrSts *cs)
{
	SceCtrlData		pad;
	int				pos,ret;
	DrawImg			*image;

	CurveBox( 240-316/2, 70, 318, 4+12+4+12+4+7*13+8, 4, gSCor[1], gSCor[2] );	// _CAOO`
	mh_print( 240-316/2+10, 70+4, "j[", gSCor[1] );
	DrawMenuTab(tab);

	pos = 0;
	if (tab==0 && gSave) pos = 2;								// XVĂȂu㏑ۑv
	if (tab==1 && sel&0x02) pos = 2;							// ͈͎w蒆ȂuRs[v
	DrawMenu( tab,pos,-1,sel );									// j[ڂ̏
	Unpush();													// {^܂őҋ@

	while (!gExitRequest){										// L[̓[v
		sceCtrlReadBufferPositive(&pad, 1);
		ret = SIMEgetchar(pad);
		switch (ret){
		case SIME_KEY_CIRCLE:									// 
			image = ScreenCopy();								// ʃC[Wj[܂߂ĕۑ
			ret = MenuSelect( filepath,tab,pos,cs );
			if (ret!=-2){
				DrawImgFree(image);								// ʃC[Wp
				return (ret);
			} else {
				ScreenPaste(image);								// ʃC[W𕜌
				DrawSts( cs, 1 );								// [[nƃXN[o[XV
			}
			break;
		case SIME_KEY_START:									// [START]
		case SIME_KEY_CROSS:									// ~
			return (0);
			break;
		case SIME_KEY_TRIANGLE:									// 
			break;
		case SIME_KEY_LEFT:										// 
			tab--;
			if (tab<0) tab = 2;
			DrawMenuTab(tab);
			DrawMenu( tab,pos,0,sel );
			break;
		case SIME_KEY_RIGHT:									// 
			tab++;
			if (tab>2) tab = 0;
			DrawMenuTab(tab);
			DrawMenu( tab,pos,0,sel );
			break;
		case SIME_KEY_UP:										// 
			pos--;
			if (pos<0) pos = 6;
			DrawMenu( tab,pos,0,sel );
			break;
		case SIME_KEY_DOWN:										// 
			pos++;
			if (pos>6) pos = 0;
			DrawMenu( tab,pos,0,sel );
			break;
		}
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}
	return (-1);
}

//==============================================================
// main
//--------------------------------------------------------------

//----- EXN[ -----

void RightShift(struct strCsrSts *cs,int vx)
{
	DrawCursor(-1);												// SIMẼJ[\ƃEBhȄ
	RollRight(vx);
	gXShift = 0;
	gXDraw = vx;												// ʍ̕ݒ
	DrawFullRec2( ShiftRNo(cs->rno,-cs->cy),cs->pline );
	gXShift = 0;
	gXDraw = LWIDTH;
	DrawSts( cs, 1 );											// [[nƃXN[o[
}

//----- XN[ -----

void LeftShift(struct strCsrSts *cs,int vx)
{
	DrawCursor(-1);												// SIMẼJ[\ƃEBhȄ
	RollLeft(vx);
	gXShift = LWIDTH - vx - gFWidth;
	gXDraw = LWIDTH;											// ʉE̕ݒ
	DrawFullRec2( ShiftRNo(cs->rno,-cs->cy),cs->pline );
	gXShift = 0;
	gXDraw = LWIDTH;
	DrawSts( cs, 1 );											// [[nƃXN[o[
}

//----- C -----

int	main(int argc,char **argv)
{
	SceCtrlData			pad,pad2;
	struct strCsrSts	cs;
	char				str[128],msg[128],textFile[1024];
	int					x,y,tab,cppst,ret,mret,save,off1,off2,dcFlag;
	long				i,bak,rno;
	float				vy,xoffBuf;
	DrawImg				*image;

	SetupCallbacks();

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);

	gLineListMax = 1000;
	gText = (struct strText**) malloc( sizeof(struct strText*) * gLineListMax );
	for (i=0; i<gLineListMax ;i++){								// sR[hXg
		gText[i] = NULL;
	}

	if (getcwd( gFolder,1024 )==NULL){							// JgfBNg̎擾
		strcpy( gFolder,"ms0:");
	}
	strcat( gFolder,"/" );
	strcpy( gPFolder,gFolder );									// t@C\t̑ΏۃtH_

	//----- intraFont -----

	x = 0;
	y = 0;

	initGraphics();
	flipScreen();												// ftHgł̓y[Wݒɕsŝ
	DiaBox1( x, y, 0, "intraFont[h", gSCor[0], gSCor[1], gSCor[2] );
	ScreenView();												// ʍXV
	if (pf_setIntraFont()){
		DiaBox1( x+20, y+10, 0, "intraFont 'japanese font' ̃[hɎs܂B", gSCor[0], gSCor[3], gSCor[4] );
		WaitBtn();												// ܂őҋ@
	}
	x += 15;
	y += 20;

	//----- monafontǂݍ -----

	strcpy( gMonaFile[0],gFolder );
	strcat( gMonaFile[0],"FONT/monafont12A.bin" );
	strcpy( gMonaFile[1],gFolder );
	strcat( gMonaFile[1],"FONT/monafont12W.bin" );
	strcpy( gMonaFile[2],gFolder );
	strcat( gMonaFile[2],"FONT/monafont16A.bin" );
	strcpy( gMonaFile[3],gFolder );
	strcat( gMonaFile[3],"FONT/monafont16W.bin" );

	LoadEnv();													// ݒt@Cǂݍ

	DiaBox1( x, y, 0, "monafont[h", gSCor[0], gSCor[1], gSCor[2] );
	ScreenView();												// ʍXV
	msg[0] = '\0';
	ret = 0;
	if ( (ret=pf_setMonaFont(0,gMonaFile[0],gMonaFile[1])) ){
		strcat( msg,"12hbgmonafont" );
	}
	if (pf_setMonaFont(1,gMonaFile[2],gMonaFile[3])){
		if (ret){
			strcat( msg,"" );
		}
		strcat( msg,"16hbgmonafont" );
	}
	if (strlen(msg)){
		strcat( msg,"̃[hɎs܂B" );
		DiaBox1( x+20, y+10, 0, msg, gSCor[0], gSCor[3], gSCor[4] );
		Unpush();												// {^܂őҋ@
		WaitBtn();												// ܂őҋ@
	}
	x += 15;
	y += 20;

	//----- SimpleIME -----

	DiaBox1( x, y, 0, "t@C[h", gSCor[0], gSCor[1], gSCor[2] );
	ScreenView();												// ʍXV
	ret = InitSIME(0);											// ǂݍ݂Ɗe평iwi̎ȕ[hj
	switch(ret){
	case 1:
		strcpy( msg,"sȎt@CłB" );
		break;
	case 2:
		strcpy( msg,"ȂĎǂ߂܂łB" );
		break;
	case 3:
		strcpy( msg, "iSIME.DICjJ܂łB" );
		break;
	}
	if (ret){													// G[Ă
		strcat( msg,"\nϊ@\\gpo܂B" );
		DiaBox1( x+20, y+10, 0, msg, gSCor[0], gSCor[3], gSCor[4] );
		Unpush();												// {^܂őҋ@
		WaitBtn();												// ܂őҋ@
	}
	x += 15;
	y += 20;

	//----- t@CI -----

	gFont = pf_fontType(gFont);									// ftHgtHgw
	setScreen();												// p[^ύX
	SIMEfont(gFont,(gFont==2 ? 16 : 12));						// SIMEϊstHg

	if (SelectFile("ҏW镶͂Ił",gFolder,"NEW.TXT",textFile,0)){
		strcpy( textFile,gFolder );
		strcat( textFile,"NEW.TXT" );							// t@CIȂ̃t@C
	}
	DiaBox1( -1, 100, 0, "t@Cǂݍł܂B\nX҂B", gSCor[0], gSCor[1], gSCor[2] );
	MenuLoad(textFile);

	Fill(0, 0, 480, 272, 0);									// ʏ

	//----- C -----

	cs.cx = 0;
	cs.sx = 0;
	cs.cy = 0;													// J[\ʒu
	cs.cxb = 0;													// J[\ʒuۑp
	cs.cxr = 0;													// J[\̘_ʒu
	cs.pline = 0;												// ʍŏ㕔̕s
	cs.rline = 0;												// J[\ʒu̘_s
	cs.adjust = 0;												// ʈʒuC
	gXOffset = 0;												// EXN[p
	gXShift = 0;
	gXDraw = LWIDTH;
	vy = 0;														// cXN[̒[Ǘ
	save = 0;
	tab = 0;													// j[
	cppst = 0;													// j[́uҏWvO[AEgw
	cs.rno = GetRNo(cs.pline+cs.cy);							// J[\ʒuɑΉ郌R[h
	DrawTitle(textFile);
	DrawSts( &cs, 1 );											// [[nƃXN[o[
	DrawFullRec(cs.pline);										// ʑS

	x = 1;
	y = TBY;
	pad2.Buttons = 0;
	while(!gExitRequest){
		ret = 0;												// -1:VsR[h擾łȂ
		sceCtrlReadBufferPositive(&pad, 1);
		if (cs.adjust && gRoll){								// J[\\ʒuɉʂړ
			if (cs.sx<gXOffset+20){
				if (gXOffset!=0){
					xoffBuf = gXOffset;
					gXOffset = cs.sx - 60;
					if (gXOffset<0) gXOffset = 0;
					if (xoffBuf-gXOffset<400){
						RightShift( &cs,xoffBuf-gXOffset );
					} else {
						DrawFullRec(cs.pline);					// ʑS
						DrawSts( &cs, 1 );						// [[nƃXN[o[
					}
				}
			} else if (gXOffset+LWIDTH-20<cs.sx){
				if (gXOffset+LWIDTH<WWIDTH){
					xoffBuf = gXOffset;
					gXOffset = cs.sx - LWIDTH + 60;
					if (gXOffset+LWIDTH>WWIDTH) gXOffset = WWIDTH - LWIDTH;
					if (gXOffset-xoffBuf<400){
						LeftShift( &cs,gXOffset-xoffBuf );
					} else {
						DrawFullRec(cs.pline);					// ʑS
						DrawSts( &cs, 1 );						// [[nƃXN[o[
					}
				}
			}
		}
		cs.adjust = 0;
		x = cs.sx - gXOffset;
		if (x<0 || x>=LWIDTH){									// J[\ʊOȂJ[\͕\Ȃ
			SIMEcursor( 0, &x, &y);
			x = (x<0 ? 0 : LWIDTH-2);							// J[\ʊO̎SIMEϊg\ʒu
		} else {
			SIMEcursor( 2, &x, &y);								// J[\̑傫ƍWϐ̎w
		}
		y = TBY + cs.cy*gFHeight;								// J[\Wݒ
		StrInput( str,pad );									// 
		if (str[0]!=0){											// ͂
			if ((str[0]<32U && str[0]!='\t') || str[0]==0x7F){	// Rg[R[hꍇ
				switch(str[0]){
				case SIME_KEY_START:							// j[
					tab = 0;
					cppst = 0;
					if (gTextClip!=NULL){						// Rs[͂Ȃ
						tab = 1;
					}
					if (gTSel[0].rno==gTSel[1].rno && gTSel[0].cxr==gTSel[1].cxr)
						gTSel[0].rno = -1;
					if (gTSel[0].rno!=-1){						// ͈͑I
						tab = 1;
						cppst |= 0x02;
					}
					if (gTextClip!=NULL) cppst |= 0x01;
					if (gUndoSize!=0) cppst |= 0x04;
					image = ScreenCopy();
					mret = menu(textFile,tab,cppst,&cs);
					if (mret!=3){
						ScreenPaste(image);
					} else {
						DrawImgFree(image);
					}
					if (mret==1){								// ʂ
						cs.cx = cs.cy = cs.cxb = cs.cxr = cs.pline = cs.rline = 0;
						cs.sx = 0;
						cs.rno = GetRNo(cs.pline+cs.cy);
						DrawTitle(textFile);
						DrawSts( &cs, 1 );
						DrawFullRec(cs.pline);					// ʑS
					} else if (mret==2){
						DrawFullRec(cs.pline);					// ʑS
					}
					Unpush();									// {^܂őҋ@
					break;
				case SIME_KEY_SELECT:							// 
//					if (gTSel[0].rno==-1){
//						gTSel[0].rno = cs.rno;
//						gTSel[0].cxr = cs.cxr;
//					} else {
//						gTSel[0].rno = -1;
//						DrawFullRec(cs.pline);
//					}
					break;
				case SIME_KEY_LTRIGGER:							// [L]
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					bak = cs.pline;
					cs.pline -= PAGEMOVE;
					if (cs.pline<0) cs.pline = 0;
					rno = cs.rno;
					for (i=0; i<bak-cs.pline ;i++){				// J[\ʒu̘_s
						rno = gText[rno]->chainBack;
						if (gText[rno]->enter) (cs.rline)--;
					}
					cs.rno = ShiftRNo( cs.rno,cs.pline-bak );
					CMSet( &cs.cx, &cs.sx, &cs.cxr, cs.cxb+1, cs.rno, 1 );	// J[\ʒu̕␳
					gTSel[1].rno = cs.rno;
					gTSel[1].cxr = cs.cxr;
					gTSel[1].line = cs.pline + cs.cy;
					if (bak!=cs.pline){
						if (gTSel[0].rno!=-1){
							DrawRec( cs.cy,ShiftRNo(cs.rno,(bak-cs.pline)) );
						}
						for (i=0; i<bak-cs.pline ;i++){
							RollDown(0);
							if (gTSel[0].rno!=-1 && cs.cy!=0){
								DrawRec( cs.cy,ShiftRNo(cs.rno,(bak-cs.pline)-i-1) );
							}
							DrawRec( 0,ShiftRNo(cs.rno,((bak-cs.pline)-i-1)-(cs.cy)) );
							ScreenView();						// ʍXV
						}
					}
					break;
				case SIME_KEY_RTRIGGER:							// [R]
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					bak = cs.pline;
					cs.pline += PAGEMOVE;
					if (cs.pline+gSLine-1-gReDraw>gLineMax){
						cs.pline = gLineMax - gSLine+1 + gReDraw;
						if (cs.pline<0) cs.pline = 0;
					}
					rno = cs.rno;
					for (i=0; i<cs.pline-bak ;i++){				// J[\ʒu̘_s
						if (gText[rno]->enter) (cs.rline)++;
						rno = gText[rno]->chainNext;
					}
					cs.rno = ShiftRNo( cs.rno,cs.pline-bak );
					CMSet( &cs.cx, &cs.sx, &cs.cxr, cs.cxb+1, cs.rno, 1 );	// J[\ʒu̕␳
					gTSel[1].rno = cs.rno;
					gTSel[1].cxr = cs.cxr;
					gTSel[1].line = cs.pline + cs.cy;
					if (bak!=cs.pline){
						if (gTSel[0].rno!=-1){
							DrawRec( cs.cy,ShiftRNo(cs.rno,(cs.cy)-(cs.pline-bak)-(cs.cy)) );
						}
						for (i=0; i<cs.pline-bak ;i++){
							RollUp( 0 );
							if (gTSel[0].rno!=-1 && cs.cy!=gSLine-1 && !(gReDraw && cs.cy==gSLine-2)){
								DrawRec( cs.cy,ShiftRNo(cs.rno,(cs.cy)-(cs.pline-bak -i-1)-(cs.cy)) );
							}
							if (gReDraw){
								DrawRec( gSLine-2,ShiftRNo(cs.rno,(gSLine-2)-(cs.pline-bak -i-1)-(cs.cy)) );
							}
							DrawRec( gSLine-1,ShiftRNo(cs.rno,(gSLine-1)-(cs.pline-bak -i-1)-(cs.cy)) );
							ScreenView();						// ʍXV
						}
					}
					break;
				case SIME_KEY_CIRCLE:							// 
					if (gTSel[0].rno==gTSel[1].rno && gTSel[0].cxr==gTSel[1].cxr)
						gTSel[0].rno = -1;
					if (gTSel[0].rno!=-1){
						TextDel(&cs);
						gTSel[0].rno = -1;
						DrawFullRec(cs.pline);					// ʑS
					}
					ret = AddRet( &cs,1,1 );
					if (!ret) gSave = 1;
					cs.adjust = 1;
					break;
				case SIME_KEY_UP:								// 
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					CMUp( &cs, 1 );
					cs.adjust = 1;
					break;
				case SIME_KEY_DOWN:								// 
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					CMDown( &cs, 1 );
					cs.adjust = 1;
					break;
				case 0x7F:										// [DEL]
				case 0x08:										// [BS]
					if (gTSel[0].rno==gTSel[1].rno && gTSel[0].cxr==gTSel[1].cxr)
						gTSel[0].rno = -1;
					if (gTSel[0].rno!=-1){
						TextDel(&cs);
						gTSel[0].rno = -1;
						DrawFullRec(cs.pline);					// ʑS
						cs.adjust = 1;
						break;
					}
					gSave = 1;
					if (str[0]==0x7F){							// [DEL]
						DelStr( &cs,1,1 );						// J[\ʒu̕폜
						cs.adjust = 1;
						break;
					}
				case SIME_KEY_LEFT:								// 
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					CMLeft( &cs,1 );
					if (str[0]==0x08){
						DelStr( &cs,1,1 );						// J[\ʒu̕폜
					}
					cs.adjust = 1;
					break;
				case SIME_KEY_RIGHT:							// 
					if (!(pad.Buttons & PSP_CTRL_CROSS)) gTSel[0].rno = -1;
					CMRight( &cs, 1 );
					cs.adjust = 1;
					break;
				}
			} else {											// ꍇ
				if (gTSel[0].rno==gTSel[1].rno && gTSel[0].cxr==gTSel[1].cxr)
					gTSel[0].rno = -1;
				if (gTSel[0].rno!=-1){
					TextDel(&cs);
					gTSel[0].rno = -1;
					DrawFullRec(cs.pline);						// ʑS
				}
				gSave = 1;
				ret = AddStr( &cs, str, 1, 1 );
				cs.adjust = 1;
			}
			if (save!=gSave){									// uXVv̏
				save = gSave;
				DrawTitle(textFile);
				DrawSts( &cs, 1 );								// Xe[^XXV
			} else {
				DrawSts( &cs, 0 );								// Xe[^XXV
			}
			if (!(pad.Buttons & PSP_CTRL_CROSS) && (pad2.Buttons & PSP_CTRL_CROSS) && str[0]!=SIME_KEY_START){
				if (gTSel[0].rno==gTSel[1].rno && gTSel[0].cxr==gTSel[1].cxr){
					gTSel[0].rno = -1;							// ͈͂w肳ĂȂ̂łꂾ
				} else {
					gTSel[0].rno = -1;
					DrawFullRec(cs.pline);						// ʑS
				}
			} else if ((pad.Buttons & PSP_CTRL_CROSS) && !(pad2.Buttons & PSP_CTRL_CROSS)){
				gTSel[0].rno = cs.rno;
				gTSel[0].cxr = cs.cxr;
				gTSel[0].line = cs.pline + cs.cy;
			}
			if (str[0]!=SIME_KEY_START){
				pad2 = pad;
			}
		}

		dcFlag = 0;												// J[\̏dsȂ߂̃tOiiiɃXN[ꍇ̑Ήj
		if (gRoll){
			if (pad.Lx<128){									// AiOpbhɂ鉡XN[
				if (pad.Lx<(128-32)){							// 
					off1 = gXOffset;
					gXOffset += (pad.Lx-128+33)/16;
					if (gXOffset<0) gXOffset = 0;
					off2 = gXOffset;
					if (off1!=off2){
						RightShift( &cs,off1-off2 );			// ʕ\Eɂ炷
						dcFlag = 1;
					}
				}
			} else {
				if (pad.Lx>128+32){								// E
					off1 = gXOffset;
					gXOffset += (pad.Lx-128-32)/16;
					if (gXOffset>WWIDTH-LWIDTH) gXOffset = WWIDTH-LWIDTH;
					off2 = gXOffset;
					if (off1!=off2){
						LeftShift( &cs,off2-off1 );				// ʕ\ɂ炷
						dcFlag = 1;
					}
				}
			}
		}
		if (pad.Ly<128){										// AiOpbhɂcXN[
			if (pad.Ly<(128-32)){
				off1 = vy;
				vy += (float)(pad.Ly-128+33)/200;
				off2 = vy;
				if (off1!=off2){
					vy += 1;
					if (cs.pline!=0){
						cs.pline--;
						cs.rno = ShiftRNo( cs.rno,-1 );
						if (gText[cs.rno]->enter) (cs.rline)--;					// J[\ʒu̘_s
						CMSet( &cs.cx, &cs.sx, &cs.cxr, cs.cxb+1, cs.rno, 1 );	// J[\ʒu̕␳
						gTSel[1].rno = cs.rno;
						gTSel[1].cxr = cs.cxr;
						gTSel[1].line = cs.pline + cs.cy;
						if (!dcFlag) DrawCursor(-1);							// J[\̏
						RollDown(0);
						if (gTSel[0].rno!=-1){
							DrawRec( cs.cy, cs.rno );
							if (cs.cy<gSLine-1){
								DrawRec( cs.cy+1, gText[cs.rno]->chainNext );
							}
						}
						DrawRec( 0, ShiftRNo(cs.rno,-cs.cy) );
						DrawSts( &cs, 1 );										// [[nƃXN[o[
					}
				}
			}
		} else {
			if (pad.Ly>128+32){
				off1 = vy;
				vy += (float)(pad.Ly-128-32)/200;
				off2 = vy;
				if (off1!=off2){
					vy -= 1;
					if (cs.pline+gSLine-1-gReDraw<gLineMax){
						cs.pline++;
						if (gText[cs.rno]->enter) (cs.rline)++;					// J[\ʒu̘_s
						cs.rno = ShiftRNo( cs.rno,1 );
						CMSet( &cs.cx, &cs.sx, &cs.cxr, cs.cxb+1, cs.rno, 1 );	// J[\ʒu̕␳
						gTSel[1].rno = cs.rno;
						gTSel[1].cxr = cs.cxr;
						gTSel[1].line = cs.pline + cs.cy;
						if (!dcFlag) DrawCursor(-1);							// J[\̏
						RollUp( 0 );
						if (gTSel[0].rno!=-1 && cs.cy!=gSLine-1){
							if (cs.cy!=0){
								DrawRec( (cs.cy)-1, gText[cs.rno]->chainBack );
							}
							DrawRec( cs.cy, cs.rno );
						}
						if (gReDraw || cs.cy==gSLine-1){
							DrawRec( gSLine-2, ShiftRNo(cs.rno,gSLine-2-(cs.cy)) );
						}
						DrawRec( gSLine-1, ShiftRNo(cs.rno,gSLine-1-(cs.cy)) );
						DrawSts( &cs, 1 );										// [[nƃXN[o[
					}
				}
			}
		}

		if (ret){
			image = ScreenCopy();
			strcpy( msg,"gpł郁ȂȂ܂B\nȏ㕶ǉł܂B" );
			DiaBox1( -1, 110, 0, msg, gSCor[0], gSCor[3], gSCor[4] );	// ɕ\
			Unpush();											// {^܂őҋ@
			WaitBtn();											// ܂őҋ@
			ScreenPaste(image);
		}

		sceDisplayWaitVblankStart();
			ScreenView();										// ʍXV
	}

	//----- I -----

	SaveEnv();
	EndSIME();
	pf_endMonaFont();
	pf_endIntraFont();
 	sceKernelExitGame();
	return 0;
}


//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;
	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
